package spujol.tfg.sp 
{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.SharedObject;
	
	import spujol.tfg.sp.screens.basic.Screen;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	import spujol.tfg.sp.screens.gear.ScreenRegister;
	import spujol.tfg.sp.screens.gear.ScreenLogin;
	import spujol.tfg.sp.screens.gear.ScreenSettings;
		
	import spujol.tfg.sp.screens.gear.ScreenChangePass;
	import spujol.tfg.sp.screens.gear.ScreenRecoverPass;

	import spujol.tfg.sp.screens.gear.ScreenText;
	import spujol.tfg.sp.screens.gear.ScreenPopUpOne;
	import spujol.tfg.sp.screens.gear.ScreenPopUpTwo;
	
	import spujol.tfg.sp.screens.app.ScreenRecipeBook;
	import spujol.tfg.sp.screens.app.ScreenNewRecipe_I;
	import spujol.tfg.sp.screens.app.ScreenNewRecipe_P;
	import spujol.tfg.sp.screens.app.ScreenNewRecipe_D;
	import spujol.tfg.sp.screens.app.ScreenSearchRecipe;
	import spujol.tfg.sp.screens.app.ScreenViewRecipe;
	import spujol.tfg.sp.screens.app.ScreenCollection;
	import spujol.tfg.sp.screens.app.ScreenMyRecipes;
	
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */

	public class Main extends Sprite
	{
		
		public var screenContainer_sp:Sprite;
		public var grandPa:int;
		private var _screenReference:Screen; 
		private var _actualScreen:int;
		private var _history:Array;
		
		private var _sharedObjectUser:SharedObject;
		private var _sharedObject:SharedObject;
		private var _size:Number;
		private var _state:Boolean;
		private	var _id:int;
		private	var _name:String;
		private	var _email:String;
		private var _from:String;
		private var _dataRecipe:Object = null;
		private var _recipe:Object = null;
		private var _recipeCol:Object = null;
		
		private var _popUp:Object = 
			{
				text:String,
				nextScreen:int
			}
			
		private var _popUpTwo:Object = 
			{
				text:String,
				nextScreen:int,
				userID:int
			}
			
		private var _dbAPI:DBappAPI;
		private var _arrayData:Array = null;
		private var _collection:Object;
		
		
		public function Main()
		{
			super();
						
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		/**
		* This method gets data for initialize screen New recipe ingredients.
		*/
		private function newRecipeInit(ev:DBAPIEvent):void{
			_arrayData = ev.data;				
		}
		
		
		/**
		* This method initializes the object.
		*/
		private function init( ev:Event ):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
					
			_history = new Array();		
					
			getShareObjectData();
			
			if (_size == 0) {		
					_actualScreen = ScreenTypes.SCREEN_REGISTER;
					
			} else {	
					_actualScreen = ScreenTypes.SCREEN_RECIPEBOOK;
			}
			
			refreshScreen();
			
			stage.nativeWindow.addEventListener(Event.CLOSING, onClosingApp);
		}
		
		
		/**
		* This method lets return back.
		*/
		private function onScreenBack(ev:ScreenEvent):void {
			getShareObjectData();
			
			// Remove the last item in history array or restart it
			if ((_actualScreen == ScreenTypes.SCREEN_REGISTER) || (_actualScreen == ScreenTypes.SCREEN_LOGIN)){ _history.length = 0;}
			else {_actualScreen = _history.pop(); }
		
			
			
			//If its a pop up screen only remove it and its listener.
			if ((_actualScreen == ScreenTypes.SCREEN_POPUPONE)||(_actualScreen == ScreenTypes.SCREEN_POPUPTWO)) { 
				screenContainer_sp.removeChildAt(1);
				_screenReference.removeEventListener(ScreenEvent.BACK, onScreenBack);
			} else { refreshScreen();}
		}
		
		
		/**
		* This method changes id screen.
		*/
		private function onScreenChange(ev:ScreenEvent):void {
			trace("screenCHANGE");
			
			getShareObjectData();
			
			switch(_actualScreen)
			{
				case ScreenTypes.SCREEN_REGISTER:
					_from = "register";
					_popUp.text = "¡Bienvenid@, "+_name+"! \nTus datos se han registrado correctamente.";
					_popUp.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK; // amb l'app finalitzada serà menú!
				break;
				
				case ScreenTypes.SCREEN_SETTINGS:
					_from = "settings";
					_popUpTwo.text = "Seguro que quieres cerrar la sesión?";
					_popUpTwo.nextScreen = ScreenTypes.SCREEN_LOGIN;
				break;
				
				case ScreenTypes.SCREEN_RECOVERPASS:
					_from = "recoverPass";
					_popUp.text = "Te hemos enviado una nueva contraseña. \nPor seguridad, \ndeberías modificarla lo antes posible.";
					_popUp.nextScreen = ScreenTypes.SCREEN_LOGIN;
				break;
				
				case ScreenTypes.SCREEN_CHANGEPASS:
					_from = "changePass";
					_popUp.text = _name+ ", \ntu contraseña ha sido modificada.";
					_popUp.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK; // amb l'app finalitzada serà menú!
				break;
				
				case ScreenTypes.SCREEN_RECIPEBOOK:
					_from = "recipeBook";
					_collection = ev.data;
					
					_popUpTwo.text = _name+ ", \n¿seguro que quieres salir de la aplicación?";
					
				break;
				
				case ScreenTypes.SCREEN_NEWRECIPE_I:
					_from = "newRecipeI";
					_popUpTwo.text = _name+ ", \nlas modificaciones no han sido guardadas. ¿Quieres continuar?";
					_popUpTwo.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK;
					
				break;
				
				case ScreenTypes.SCREEN_NEWRECIPE_P:
				_from = "newRecipeP";
					_popUpTwo.text = _name+ ", \nlas modificaciones no han sido guardadas. ¿Quieres continuar?";
					_popUpTwo.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK;
					
				break;
				
				case ScreenTypes.SCREEN_NEWRECIPE_D:
					_from = "newRecipeD";
					_popUp.text = _name+ ", \nTu receta se ha guardado correctamente.";
					_popUp.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK;
					
					_popUpTwo.text = _name+ ", \nlas modificaciones no han sido guardadas. ¿Quieres continuar?";
					_popUpTwo.nextScreen = ScreenTypes.SCREEN_RECIPEBOOK;
					
				break;
				
				case ScreenTypes.SCREEN_SEARCHRECIPE:
					_from = "searchRecipe";
					_dataRecipe = ev.data;
				break;
				
				case ScreenTypes.SCREEN_VIEWRECIPE:
					_from = "viewRecipe";
					_recipe = ev.data;
					
				break;
				
				case ScreenTypes.SCREEN_COLLECTION:
					_from = "collection";
					_recipeCol = ev.data;
				break;
				
				case ScreenTypes.SCREEN_MYRECIPES:
					_from = "myRecipes";
					_recipeCol = ev.data;
					_recipe = ev.data;
					
					if (_recipe!= null){
					_popUpTwo.text = _name+ ", \n¿Seguro que quieres eliminar esta receta?\n"+_recipe.recipeName;
					_popUpTwo.nextScreen = ScreenTypes.SCREEN_MYRECIPES;
					_popUpTwo.userID = _id;
					_popUpTwo.recipeID = _recipe.recipeID;}
					
				case ScreenTypes.SCREEN_POPUPTWO:
					_collection = ev.data;
					
				break;
				
				
				default:
				break;
			}
			
			
			if ((ev.screenID != _actualScreen) || (( _actualScreen == 13) && ( ev.screenID == 13))) {
				_history.push(_actualScreen);
				_actualScreen = ev.screenID;	
							
				refreshScreen();
			}
		}
		
		
		/**
		* This method adds actual screen in displaylist.
		*/
		private function refreshScreen():void
		{	
			if (_screenReference != null) { 
				// Remove listeners
				_screenReference.removeEventListener(ScreenEvent.BACK, onScreenBack);
				_screenReference.removeEventListener(ScreenEvent.CHANGE_SCREEN,  onScreenChange);
				
				// Remove previous screen from de displaylist
				if ((_actualScreen != ScreenTypes.SCREEN_POPUPONE) && (_actualScreen != ScreenTypes.SCREEN_POPUPTWO)) {
					while (screenContainer_sp.numChildren){
						screenContainer_sp.removeChildAt(0);
					}
				}
			}
			
			// Screeens instances
			switch (_actualScreen)
			{
				case ScreenTypes.SCREEN_REGISTER:_screenReference = new ScreenRegister(); break;
				case ScreenTypes.SCREEN_LOGIN:_screenReference = new ScreenLogin(); break;
				case ScreenTypes.SCREEN_SETTINGS:_screenReference = new ScreenSettings(_state, _name, _email); break;
				
				case ScreenTypes.SCREEN_CHANGEPASS:_screenReference = new ScreenChangePass(_name); break;
				case ScreenTypes.SCREEN_RECOVERPASS:_screenReference = new ScreenRecoverPass(); break;
				
				case ScreenTypes.SCREEN_TEXT:_screenReference = new ScreenText(_from); break;
				case ScreenTypes.SCREEN_POPUPONE:_screenReference = new ScreenPopUpOne(_from, _popUp); break;
				case ScreenTypes.SCREEN_POPUPTWO:_screenReference = new ScreenPopUpTwo(_from, _popUpTwo); break;
				
				case ScreenTypes.SCREEN_RECIPEBOOK:
					_screenReference = new ScreenRecipeBook(_history, _state, _id, _name, _email); 
					
					_dbAPI = new DBappAPI();
					_dbAPI.addEventListener(DBAPIEvent.COMPLETE, newRecipeInit);
					_dbAPI.loadInputArray("recipeInit");
					
				break;
				
				case ScreenTypes.SCREEN_NEWRECIPE_I:

						grandPa = _history[_history.length - 3];
					
						if ((_from == "viewRecipe") && (grandPa == 9)){
							_screenReference = new ScreenNewRecipe_I(_state, _name, _arrayData, _recipe);	
						} else if ((_from == "viewRecipe") && (grandPa == 8)){
							_screenReference = new ScreenNewRecipe_I(_state, _name, _arrayData, null, _recipe);
						} else if (_from == "myRecipes"){
							_screenReference = new ScreenNewRecipe_I(_state, _name, _arrayData, null, null, _recipe);
						} else {
							_screenReference = new ScreenNewRecipe_I(_state, _name, _arrayData);
						}
					
				break;
				
				case ScreenTypes.SCREEN_NEWRECIPE_P:_screenReference = new ScreenNewRecipe_P(_state, _name); break;
				case ScreenTypes.SCREEN_NEWRECIPE_D:_screenReference = new ScreenNewRecipe_D(_state, _name, _arrayData); break;
				
				case ScreenTypes.SCREEN_SEARCHRECIPE:_screenReference = new ScreenSearchRecipe(_state, _arrayData, _id); break;
				
				case ScreenTypes.SCREEN_VIEWRECIPE:
					grandPa = _history[_history.length - 2];
					
					if (_from == "searchRecipe"){
						_screenReference = new ScreenViewRecipe(_state, _dataRecipe, grandPa, _id);	
					} else if (_from == "viewRecipe") {
						_screenReference = new ScreenViewRecipe(_state, _recipe, grandPa, _id);
						if (grandPa == 12){_recipe = _dataRecipe;}
						else if ((grandPa == 14)||(grandPa == 15)){_recipe = _recipeCol;}
					} else if ((_from == "collection") || (_from == "myRecipes")) {
						_screenReference = new ScreenViewRecipe(_state, _recipeCol, grandPa, _id);
					}				
				break;
				
				case ScreenTypes.SCREEN_COLLECTION:_screenReference = new ScreenCollection(_state, _id, _collection); break;
				
				case ScreenTypes.SCREEN_MYRECIPES: _screenReference = new ScreenMyRecipes(_state,  _id, _collection); 
				
				break;
				
			}
			
			// Listeners
			_screenReference.addEventListener(ScreenEvent.BACK, onScreenBack);
			_screenReference.addEventListener(ScreenEvent.CHANGE_SCREEN,  onScreenChange);
			
			// Add screen in displaylist
			screenContainer_sp.addChild(_screenReference);
			
			trace("Número de hijos dentro de screenContainer_sp: " + screenContainer_sp.numChildren );
			trace ("_actualScreen: " + _actualScreen);
		}	
		
		/**
		* This method gets ShareObject's data.
		*/
		private function getShareObjectData():void {
			
			_sharedObjectUser = SharedObject.getLocal("userData"); 
			
			_state = _sharedObjectUser.data.help;
			_id = _sharedObjectUser.data.id;
			_name = _sharedObjectUser.data.name;
			_email = _sharedObjectUser.data.email;
			_size = _sharedObjectUser.size;
		}
		
		
		/**
		* This method does what app needs to close well.
		*/
		private function onClosingApp(ev:Event):void {
			_sharedObject = SharedObject.getLocal("searchRecipe");
			_sharedObject.clear();
			
			_sharedObject = SharedObject.getLocal("newRecipe");
			_sharedObject.clear();
			
			_sharedObject = SharedObject.getLocal("viewRecipe");
			_sharedObject.clear();
			
			_sharedObject = SharedObject.getLocal("myRecipes");
			_sharedObject.clear();
		}
		
	}
}