package spujol.tfg.sp.api 
{
	import flash.display.MovieClip; 

	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	import flash.net.URLVariables;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.navigateToURL;

	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class DBAPI extends EventDispatcher
	{
		private var _data:Array;
		private var _urlLoader:URLLoader;
		private var _variables:URLVariables;
		private var _emailSend:Boolean;
		
		public function DBAPI() 
		{ 
			_urlLoader = new URLLoader();
			_data = new Array();
			_variables  = new URLVariables(); 
			_emailSend = false;
		} 
		
		/**
		* This method connects with PHP file and sends data.
		*/
		private function loadData(functionName:Function){
			
			var url:String = "http://eimtcms.uoc.edu/~soniapf/php/userDataBase.php";
			var urlRequest:URLRequest = new URLRequest(url);
			
			urlRequest.method = URLRequestMethod.POST;	
			urlRequest.data = _variables;
			
			_urlLoader.addEventListener(Event.COMPLETE,functionName);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR,onError);
			
			_urlLoader.load(urlRequest);
		}
		
		
		/**
		* This method connects with PHP file to send an email.
		*/
		private function sendMail(){
			
			var url:String = "http://eimtcms.uoc.edu/~soniapf/php/sendMail.php";
			var urlRequest:URLRequest = new URLRequest(url);
			
			urlRequest.method = URLRequestMethod.POST;	
			urlRequest.data = _variables;
			
			_urlLoader.addEventListener(Event.COMPLETE,sendMailComplete);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR,onError);
			
			_urlLoader.load(urlRequest);
			trace ("send mail");
		}
		
		
		/**
		* This method sends data to php
		*/
		public function loadUserData(from:String, userId:int, userName:String, userEmail:String, userPass:String, newPass:String):void{ 
			
			_variables.from = (from == "")? "unknown":from;	
			_variables.userId = (userId == -1)? -1:userId;	
			_variables.userName = (userName == "")? "unknown":userName;	
			_variables.userEmail = (userEmail == "")? "unknown":userEmail;	
			_variables.userPass = (userPass == "")? "unknown":userPass;	
			_variables.newPass = (newPass == "")? "unknown":newPass;	
			
			if (from == "recoverPassChange"){
				var str:String = createNewPass();
				_variables.newPass = str;	
				trace ("new pass= " + str);
				sendMail();				
			} else {
				loadData(loadUserDataComplete);
			}
		}
		
		
		
		/**
		* This method displays data returned back from PHP file with XML.
		*/
		private function loadUserDataComplete(ev:Event):void {
			trace (_urlLoader.data);
			var data:Object;
			data = JSON.parse(_urlLoader.data);
			
			for (var i:int = 0; i < data.length; i++){
				var field:String =data[i];
				_data.push(field);	
				
			}
			
			dispatchDBAPIEvent(_data);
		}
		
		
		/**
		* This method displays data returned back from PHP file with XML.
		*/
		private function sendMailComplete(ev:Event):void {
			trace (_urlLoader.data);
			var data:String =_urlLoader.data;
			
			if (data == "true") {trace ("datatrue"); trace (_variables); loadUserDataPost(); }
			
			dispatchDBAPIEvent(_data);
		}
		
		/**
		* This method sends data to php
		*/
		public function loadUserDataPost():void{ 

				loadData(loadUserDataComplete);

		}
		
		
		
		
		
		/**
		* This method shows an error if it happens.
		*/
		private function onError(event:IOErrorEvent):void {
			trace("Error al cargar la url");
		}
		
		
		/**
		* This method generates a pass.
		*/
		private function createNewPass():String{
			var newPass:String = "";
			var newPassLength:int = 6;
			var string:String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
			var stringNumbers:String = "1234567890";
			var pass:Array= new Array ();
			var data:String = "";
			var maxLimit = string.length - 1;
			var maxLimitNum = stringNumbers.length - 1;
			var num:int;
			var i:int;
			
			for (i = 0; i<newPassLength-2; i++){	
				num = Math.round(Math.random()*maxLimit);	
				data += string.substr(num,1);
			}
			
			for (i = newPassLength-2; i < newPassLength; i++){	
				num = Math.round(Math.random()*maxLimitNum);	
				data += stringNumbers.substr(num,1);
			}
			
			return data;
		}
		
		
		
		
		/**
		* This method checks data.
		*/	
		private function dispatchDBAPIEvent(data:Array):void {
			var dbCompleteEvent:DBAPIEvent = new DBAPIEvent(DBAPIEvent.COMPLETE, true, false, "Request succesful", data);
			dispatchEvent(dbCompleteEvent);
		}
	}
}