package spujol.tfg.sp.api 
{
	import flash.display.MovieClip; 

	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	import flash.net.URLVariables;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.navigateToURL;


	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class DBappAPI extends EventDispatcher
	{
		private var _urlLoader:URLLoader;
		private var _variables:URLVariables;
		private var  _data:Array;
	
		public function DBappAPI() 
		{ 
			_urlLoader = new URLLoader();
			_variables  = new URLVariables();
			_data = new Array;
		} 
		
		/**
		* This method connects with PHP file and sends data.
		*/
		private function loadData(functionName:Function){
			
			var url:String = "http://eimtcms.uoc.edu/~soniapf/php/appDataBase.php";
			var urlRequest:URLRequest = new URLRequest(url);
			
			urlRequest.method = URLRequestMethod.POST;	
			urlRequest.data = _variables;
			
			_urlLoader.addEventListener(Event.COMPLETE,functionName);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR,onError);
			
			_urlLoader.load(urlRequest);
		}

		
		/**
		* This method sends data to php
		*/
		public function loadInputArray(from:String):void{ 
			
			_variables.from = from;	
			
			loadData(loadInputArrayComplete);
		}
		
		
		/**
		* This method displays data returned back from PHP file with json.
		*/
		private function loadInputArrayComplete(ev:Event):void {
			var data:Object;
			data = JSON.parse(_urlLoader.data);

			var ingr:Array;
			ingr = new Array();
			
			for (var i:int = 0; i < data[0].length; i++){
				var ingredient:String =data[0][i];
				ingr.push(ingredient);	
			}			
		
			var meas:Array;
			meas = new Array();
			
			for (var j:int = 0; j < data[1].length; j++){
				var measure:String = data[1][j];
				meas.push(measure);
			}
			
			var colle:Array;
			colle = new Array();
			
			for (var h:int = 0; h < data[2].length; h++){
				var collection:String = data[2][h];
				colle.push(collection);
			}
			
			var auth:Array;
			auth = new Array();
			
			for (var g:int = 0; g < data[3].length; g++){
				var author:String = data[3][g];
				auth.push(author);
			}
			
			
			_data.push(ingr);
			_data.push(meas);
			_data.push(colle);
			_data.push(auth);
			
			dispatchDBAPIEvent(_data);		
		}
		
		
		
		/**
		* This method sends data to php
		*/
		public function loadSearchRecipeResults(from:String, author:String, collection:String, ingredient:String, portion:String):void{ 
			
			_variables.from = from;	
			_variables.author = author;
			_variables.collection = collection;
			_variables.ingredient = ingredient;
			_variables.portion = portion;
		
			loadData(loadSearchRecipeResultsComplete);
		}
		
		/**
		* This method displays data returned back from PHP file with json.
		*/
		private function loadSearchRecipeResultsComplete(ev:Event):void {

			var data:Object;
			data = JSON.parse(_urlLoader.data);
			
			for (var i:int = 0; i < data.length; i++){
				var recipe:Array = new Array();
				var name:String = data[i][0];
				var author:String = data[i][1];
				var likes:String = data[i][2];
				var value:String = data[i][3];
				var pax:String = data[i][4];
				var id:String = data[i][5];
				var thumb:String = data[i][6];	
				var img:String = data[i][7];	
				var original:String = data[i][8];	
				var originalID:String = data[i][9];
				
				recipe.push(name);
				recipe.push(author);
				recipe.push(likes);
				recipe.push(value);
				recipe.push(pax);
				recipe.push(id);
				recipe.push(thumb);
				recipe.push(img);
				recipe.push(original);
				recipe.push(originalID);
				
				_data.push(recipe);
			}
		
			dispatchDBAPIEvent(_data);	
		}
		
		
		/**
		* This method sends data to php
		*/
		public function loadFullRecipe(from:String, recipeID:String, userID:int):void{ 
			
			_variables.from = from;	
			_variables.recipeID = recipeID;
			_variables.userID = userID;
			
			loadData(loadFullRecipeComplete);
		}
		
		/**
		* This method displays data returned back from PHP file with json.
		*/
		private function loadFullRecipeComplete(ev:Event):void {
		
			var data:Object;
			data = JSON.parse(_urlLoader.data);
			
			var ingredients:Array = new Array();
			
			for (var h:int = 0; h < data[0].length; h++){
				var ing:Array = new Array();
				var ingredient:String = data[0][h][0];
				var quantity:String = data[0][h][1];
				var measure:String = data[0][h][2];
									
				ing.push(ingredient);
				ing.push(quantity);
				ing.push(measure);
				
				ingredients.push(ing);
			}
			
			var procediments:Array = new Array();
			
			for (var i:int = 0; i < data[1].length; i++){
				var pro:Array = new Array();
				var point:String = data[1][i][0];
				var textPoint:String = data[1][i][1];

				pro.push(point);
				pro.push(textPoint);

				procediments.push(pro);
			}
			
			var reused:Array = new Array();
			
			for (var j:int = 0; j < data[4].length; j++){
				var rec:Array = new Array();
				var id2:String =  data[4][j][0];
				var recipe:String =  data[4][j][1];
				var pax2:String =  data[4][j][2];
				
				rec.push(id2);
				rec.push(recipe);
				rec.push(pax2);
				
				reused.push(rec);
			}
			
			var recipes:Object = new Object;
				recipes.name =  data[5][0];
				recipes.author =  data[5][1];
				recipes.likes =  data[5][2];
				recipes.value =  data[5][3];
				recipes.pax =  data[5][4];
				recipes.id =  data[5][5];
				recipes.thumb =  data[5][6];
				recipes.img =  data[5][7];
				recipes.original =  data[5][8];
				recipes.originalID =  data[5][9];
				recipes.collection = data[5][10];
				recipes.privacity = data[5][11];
			
			_data[0] = ingredients;
			_data[1] = procediments;
			_data[2] = data[2];
			_data[3] = data[3];
			_data[4] = reused;
			_data[5] = recipes;

			dispatchDBAPIEvent(_data);
		}
		
		
		
		/**
		* This method sends data to php
		*/
		public function loadRecipes(from:String, collection:String, userID:int):void{ 
			_variables.from = from;	
			_variables.collection = collection;
			_variables.userID = userID;
			
			loadData(loadSearchRecipeResultsComplete);
		}
		
		
		
		
		/**
		* This method shows an error if it happens.
		*/
		private function onError(event:IOErrorEvent):void {
			trace("Error al cargar la url");
		}
		
		
		/**
		* This method checks data.
		*/	
		private function dispatchDBAPIEvent(data:Array):void {
			var dbCompleteEvent:DBAPIEvent = new DBAPIEvent(DBAPIEvent.COMPLETE, true, false, "Request succesful", data);
			dispatchEvent(dbCompleteEvent);
		}
	}
}
	
