package spujol.tfg.sp.api 
{
	import flash.display.MovieClip; 
	import flash.utils.ByteArray;

	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	
	import flash.net.URLVariables;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.navigateToURL;


	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class DBsetAPI extends EventDispatcher
	{
		private var _urlLoader:URLLoader;
		private var _variables:URLVariables;
		private var  _data:Array;
	
		public function DBsetAPI() 
		{ 
			_urlLoader = new URLLoader();
			_variables  = new URLVariables();
			_data = new Array;
		} 
		
		/**
		* This method connects with PHP file and sends data.
		*/
		private function loadData(functionName:Function){
			
			var url:String ="http://eimtcms.uoc.edu/~soniapf/php/setDataBase.php";
			var urlRequest:URLRequest = new URLRequest(url);
			
			urlRequest.method = URLRequestMethod.POST;	
			urlRequest.data = _variables;
			
			_urlLoader.addEventListener(Event.COMPLETE,functionName);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR,onError);
			
			_urlLoader.load(urlRequest);
		}

		
		/**
		* This method sends data to php
		*/
		public function loadNewElements(from:String, table:String, element:String):void{ 
			
			_variables.from = from;	
			_variables.table = table;	
			_variables.element = element;

			loadData(loadNewElementsComplete);
		}
		
		/**
		* This method displays data returned back from PHP.
		*/
		private function loadNewElementsComplete(ev:Event):void {
			
			var data:Object;
			data = JSON.parse(_urlLoader.data);
			
			_data.push(data[0]);	
			_data.push(data[1]);

			dispatchDBAPIEvent(_data);
		}
		
		
		
		/**
		* This method sends data to php
		*/
		public function loadNewRecipe(from:String, ingredientsArray:Array, recipesArray:Array, preparationArray:Array, dataArray:Array, author:String, original:String, imgUrl:String = null, thumbURL:String = null):void{ 
			
			_variables.from = from;		
			_variables.author = author;
			_variables.ingredients = JSON.stringify(ingredientsArray);
			_variables.recipes = JSON.stringify(recipesArray);
			_variables.preparation = JSON.stringify(preparationArray);	
			_variables.data = JSON.stringify(dataArray);
			_variables.original = original;
			if (imgUrl == null){_variables.imgUrl = 0; } else {_variables.imgUrl = imgUrl; }
			_variables.thumbUrl = thumbURL;

			loadData(loadNewRecipeComplete);
		}
		
		/**
		* This method displays data returned back from PHP.
		*/
		private function loadNewRecipeComplete(ev:Event):void {
			
				trace (_urlLoader.data);
			dispatchDBAPIEvent(_data);
		}
		
		
		
		/**
		* This method sends data to php
		*/
		public function loadLikeChangeData(from:String, state:Boolean, recipeID:int, userID:int):void{ 
			
			_variables.from = from;		
			_variables.state = state;
			_variables.recipeID = recipeID;
			_variables.userID = userID;
			
			loadData(loadLikeChangeDataComplete);
		}

		/**
		* This method displays data returned back from PHP.
		*/
		private function loadLikeChangeDataComplete(ev:Event):void {
					
			trace (_urlLoader.data);
			dispatchDBAPIEvent(_data);
		}
		
		/**
		* This method sends data to php
		*/
		public function loadDeleteRecipe(from:String, recipeID:String):void{ 
			
			_variables.from = from;	
			_variables.recipeID = recipeID;
			
			loadData(loadDeleteRecipeComplete);
		}
		
		private function loadDeleteRecipeComplete(ev:Event):void {
					
			trace (_urlLoader.data);
			dispatchDBAPIEvent(_data);
		}
		
		/**
		* This method shows an error if it happens.
		*/
		private function onError(event:IOErrorEvent):void {
			trace("Error al cargar la url");
		}
		
		
		/**
		* This method checks data.
		*/	
		private function dispatchDBAPIEvent(data:Array):void {
			var dbCompleteEvent:DBAPIEvent = new DBAPIEvent(DBAPIEvent.COMPLETE, true, false, "Request succesful", data);
			dispatchEvent(dbCompleteEvent);
		}
	}
}
	