package spujol.tfg.sp.instances 
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.instances.ui.ColorTag;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	public class MyRecipes extends Sprite
	{
		public var delete_sp:Sprite;
		public var edit_sp:Sprite;
		public var space_sp:Sprite;
		public var tag_sp: ColorTag;
		public var recipeName_tf:TextField;
		public var recipeAuthorName_tf:TextField;
		public var likes_tf:TextField;
		public var thumbCont_sp:Sprite;
		
		public var preloader:Preloader;
		private var _dbAPI:DBappAPI;
		private var _userID:int;
		private var recipe:Object = {
						name: "",
						author: "",
						likes: "",
						value: "",
						pax: "",
						id: "",
						thumb: "",
						original: "", 
						originalID: "", 
						collection: "",
						privacity:""
					};
		
		public function MyRecipes(array:Array, userID:int) 
		{
			recipe.name = array[0];
			recipe.author = array[1];
			recipe.likes = array[2];
			recipe.value = array[3];
			recipe.pax = array[4];
			recipe.id = array[5];
			recipe.thumb = array[6];
			recipe.img = array[7];
			recipe.original = array[8];
			recipe.originalID = array[9];
			recipe.collection = array[10]
			recipe.privacity = array[11]
			_userID = userID;
			
			super();
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
	
		/**
		* This method initializes the object.
		*/
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tag_sp = new ColorTag(recipe.value);
			tag_sp.x = this.width - tag_sp.width - edit_sp.width -1;
			tag_sp.y = 0;
			addChild(tag_sp);
			
			recipeName_tf.text = recipe.name;
			likes_tf.text = recipe.likes;
			
			space_sp.buttonMode = true;
			space_sp.mouseChildren = false;
			space_sp.addEventListener(MouseEvent.CLICK, getRecipe);
			
			delete_sp.buttonMode = true;
			delete_sp.mouseChildren = false;
			delete_sp.addEventListener(MouseEvent.CLICK, deleteRecipe);
			
			edit_sp.buttonMode = true;
			edit_sp.mouseChildren = false;
			edit_sp.addEventListener(MouseEvent.CLICK, editRecipe);
			
		}
		
		/**
		* This method puts images into displaylist
		*/
		private function completeHandler(ev:Event):void {
			//Remove listeners
			removeEventListener(Event.COMPLETE, completeHandler);
		}
		
		
		/**
		* This method gets recipe procediment and ingredients from database
		*/
		private function getRecipe(ev:MouseEvent):void {						
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipe);
			_dbAPI.loadFullRecipe("viewRecipe", recipe.id, _userID);
			
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);		
		}
		
		
		/**
		* This method goes to view recipe screen.
		*/
		private function viewRecipe(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			var fullRecipe:Object = new Object();
				fullRecipe.recipe = data[5];
				fullRecipe.ingredients = data[0];
				fullRecipe.procediments = data[1]; 
				fullRecipe.likeStatus = data[2];
				fullRecipe.loveStatus = data[3];
				fullRecipe.reused = data[4];
				
			removeChild(preloader);
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_VIEWRECIPE, fullRecipe);
			dispatchEvent(screenEv);
		}
		
		/**
		* This method deletes recipe from database
		* */
		private function deleteRecipe(ev:MouseEvent):void {	
			var data:Object = new Object();
			data.recipeID = recipe.id;
			data.recipeName = recipe.name;
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_POPUPTWO, data);
			dispatchEvent(screenEv);
		}
		
		
		
		/**
		* This method lets edit recipe
		*/
		private function editRecipe(ev:MouseEvent):void {	
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, reeditRecipe);
			_dbAPI.loadFullRecipe("viewRecipe", recipe.id, _userID);
			
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);

		}
		
		
		/**
		* This method goes to view recipe screen.
		*/
		private function reeditRecipe(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			
			var _ingredientsOb:Array = new Array();
			var ingTotal:int = data[0].length;
			for (var i:int = 0; i < ingTotal; i++){
				var ing:Object = new Object();
				ing.ingredient = data[0][i][0];
				ing.quantity = data[0][i][1];
				ing.measure =  data[0][i][2];
				
				_ingredientsOb.push(ing);
			}
			
			var _procedimentsOb:Array = new Array();
			var proTotal:int = data[1].length;
			for (var j:int = 0; j < proTotal; j++){
				var pro:Object = new Object();
				pro.number = data[1][j][0];
				pro.text = data[1][j][1];

				_procedimentsOb.push(pro);
			}
			
			var _reusedOb:Array = new Array();
			var recTotal:int = data[4].length;
			for (var h:int = 0; h < recTotal; h++){
				var rec:Object = new Object();
				rec.id = data[4][h][0];
				rec.name = data[4][h][1];

				_reusedOb.push(rec);
			}

			var fullRecipe:Object = new Object();
				fullRecipe.recipe = data[5];
				fullRecipe.ingredients = _ingredientsOb;
				fullRecipe.procediments = _procedimentsOb; 
				fullRecipe.likeStatus = data[2];
				fullRecipe.loveStatus = data[3];
				fullRecipe.reused = _reusedOb;
				
			removeChild(preloader);
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_NEWRECIPE_I, fullRecipe);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			removeEventListener(Event.REMOVED_FROM_STAGE, dispose);
			removeEventListener(MouseEvent.CLICK, viewRecipe);
		}
		
	}

}