package spujol.tfg.sp.instances 
{
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	
	import spujol.tfg.sp.instances.ui.ColorTag;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class SearchRecipe extends Sprite
	{
		public var tag_sp: ColorTag;
		public var recipeName_tf:TextField;
		public var recipeAuthorName_tf:TextField;
		public var likes_tf:TextField;
		public var recipeNumPax_tf:TextField;
		public var thumbCont_sp:Sprite;
		public var preloader:Preloader;
		
		private var _dbAPI:DBappAPI;
		private var _userID:int;
		private var recipe:Object = {
						name: "",
						author: "",
						likes: "",
						value: "",
						pax: "",
						id: "",
						thumb: "",
						original: "", 
						originalID: ""
					};
					
		private var _loader:Loader;
		private var _urlRequest:URLRequest
					
		public function SearchRecipe(array:Array, userID:int) 
		{
			recipe.name = array[0];
			recipe.author = array[1];
			recipe.likes = array[2];
			recipe.value = array[3];
			recipe.pax = array[4];
			recipe.id = array[5];
			recipe.thumb = array[6];
			recipe.img = array[7];
			recipe.original = array[8];
			recipe.originalID = array[9];
			
			_userID = userID;
			
			super();
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		/**
		* This method initializes the object.
		*/
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			tag_sp = new ColorTag(recipe.value);
			tag_sp.x = this.width - tag_sp.width;
			tag_sp.y = 0;
			addChild(tag_sp);
			
			recipeName_tf.text = recipe.name;
			recipeAuthorName_tf.text = recipe.author;
			likes_tf.text = recipe.likes;
			recipeNumPax_tf.text = recipe.pax;
			
			
			if (recipe.thumb == null) {
				_loader = new Loader();
				_urlRequest = new URLRequest("http://eimtcms.uoc.edu/~soniapf/images/defaultThumb.png");
				_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);		
				_loader.load(_urlRequest);
				
			} else {
				_loader = new Loader();
				var url:String = "http://eimtcms.uoc.edu/~soniapf/php/" + recipe.thumb;
				_urlRequest = new URLRequest(url);
				_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);		
				_loader.load(_urlRequest);
			}
			
			buttonMode = true;
			mouseChildren = false;
			addEventListener(MouseEvent.CLICK, getRecipe);
			
		}
		
		/**
		* This method puts images into displaylist
		*/
		private function completeHandler(ev:Event):void {
			//Remove listeners
			removeEventListener(Event.COMPLETE, completeHandler);
			if (thumbCont_sp.numChildren > 0) {thumbCont_sp.removeChildAt(0); }
		
			var img = ev.target.content;
			img.width = (stage.stageWidth*16.6667)/100;
			img.height = img.width /1.333333;
			thumbCont_sp.addChild(img);
		}
		
		
		/**
		* This method gets recipe procediment and ingredients from database
		*/
		private function getRecipe(ev:MouseEvent):void {						
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipe);
			_dbAPI.loadFullRecipe("viewRecipe", recipe.id, _userID);
			
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);
			
		}
		
		
		/**
		* This method goes to view recipe screen.
		*/
		private function viewRecipe(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			var fullRecipe:Object = new Object();
				fullRecipe.recipe = recipe;
				fullRecipe.ingredients = data[0];
				fullRecipe.procediments = data[1]; 
				fullRecipe.likeStatus = data[2];
				fullRecipe.loveStatus = data[3];
				fullRecipe.reused = data[4];
				
			removeChild(preloader);
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_VIEWRECIPE, fullRecipe);
			dispatchEvent(screenEv);
		}
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			removeEventListener(Event.REMOVED_FROM_STAGE, dispose);
			removeEventListener(MouseEvent.CLICK, viewRecipe);
		}
		
	}

}