package spujol.tfg.sp.instances.ui 
{
	import flash.text.TextField;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.preloader.Preloader;	
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	
	public class Recipe extends Sprite
	{
		public var recipeName_tf:TextField;
		
		private var _userID:int;
		private var _dbAPI:DBappAPI;
		private var _preloader:Preloader;
		private var recipe:Object = {
						id: "",
						name: "",
						pax: ""
					};
		
		public function Recipe(id:int, name:String, userId:int, pax:String) 
		{
			recipe.id = id.toString();
			recipe.name = name;
			recipe.pax = pax;
			_userID = userId;
		
			
			
			super();
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			recipeName_tf.text = recipe.name;
			
			this.buttonMode = true;
			this.mouseChildren = false;
			this.addEventListener(MouseEvent.CLICK, getRecipe);
		}
		
		
		/**
		* This method gets recipe procediment and ingredients from database
		*/
		private function getRecipe(ev:MouseEvent):void {						
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipe);
			_dbAPI.loadFullRecipe("viewRecipe", recipe.id, _userID);
			
			_preloader = new Preloader();
			_preloader.x = stage.stageWidth/2;
			_preloader.y = stage.stageHeight/2;;
			addChild(_preloader);
			
		}
		
		
		/**
		* This method goes to view recipe screen.
		*/
		private function viewRecipe(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			var fullRecipe:Object = new Object();
				fullRecipe.recipe = data[5];
				fullRecipe.ingredients = data[0];
				fullRecipe.procediments = data[1]; 
				fullRecipe.likeStatus = data[2];
				fullRecipe.loveStatus = data[3];
				fullRecipe.reused = data[4];
				
			removeChild(_preloader);
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_VIEWRECIPE, fullRecipe);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE, dispose);
			this.removeEventListener(MouseEvent.CLICK, getRecipe);
		}
		
	}

}


			
		
		
		
		
		
		
		