package spujol.tfg.sp.screens.app 
{
	import flash.net.SharedObject;
	import flash.text.TextField;
	import flash.display.Sprite;	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TransformGestureEvent;
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	import spujol.tfg.sp.instances.MyRecipes;
	import spujol.tfg.sp.ui.bt.AppHelpIcon;
	
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	
	public class ScreenMyRecipes  extends ScreenTopBar
	{
		public var backBt_sp:Sprite;
		public var cont_sp:Sprite;
		public var helpBt_sp:AppHelpIcon;
		protected var _state:Boolean;
		protected var _tittle:String;
		protected var _results:Array;
		protected var _userID:int;	
		private var _sO:SharedObject;
		private var _totalForSwipe:int = 3;
		
		public function ScreenMyRecipes(state:Boolean, userID:int, results:Object = null) 
		{
			
				
			_state = state;	
			_userID = userID;
			if (results != null) {_results = results.array; }
			else {_results = null;}
			
			
			super();
		}
		
	
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {
			screenTitle_tf.text = "MIS RECETAS";
			
			_sO = SharedObject.getLocal("myRecipes"); 

			if (_results == null){
				_results = _sO.data.results;	
			} else {
				_sO.data.results = _results;
			}

				
			backBt_sp.buttonMode = true;
			backBt_sp.mouseChildren = false;
			backBt_sp.addEventListener(MouseEvent.CLICK, goBack);
			
			if (_state == true){
				helpBt_sp = new AppHelpIcon();
				addChild(helpBt_sp);
				helpBt_sp.addEventListener(MouseEvent.CLICK,showHelp);
			}
			
			for (var i:int = 0; i < _results.length; i++){	
				var rec:MyRecipes = new MyRecipes(_results[i], _userID);
				rec.name = "rec" + i;
				cont_sp.addChild(rec);
			}
			
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			resizeHandler();
		}
		
		
		/**
		* This method controls scroll tactil events.
		*/
		private function onSwipe(ev:TransformGestureEvent):void{

			if (ev.offsetY == -1) {
				var arrayCopy:Array = _results.slice(_totalForSwipe);
				var total:int = arrayCopy.length;
								
				if (total > 0){
					
					while (cont_sp.numChildren > 0) {
					cont_sp.removeChildAt(0);
					}
					
					for (var i:int = 0; i < arrayCopy.length; i++){	
						var rec:MyRecipes = new MyRecipes(arrayCopy[i], _userID);
						rec.name = "rec" + i;
						cont_sp.addChild(rec);
					}		
				}
				
				_totalForSwipe += 3;
				
				cont_sp.x =  stageW/2 - cont_sp.width/2;
				cont_sp.y = topBarH;
				
				if (cont_sp.numChildren > 0){	

				var posY:int = 0;

					for (var j:int = 0; j < arrayCopy.length; j++){
						cont_sp.getChildByName("rec" + j).y = posY;
						cont_sp.getChildByName("rec" + j).x = 0;
						posY += cont_sp.getChildByName("rec" + j).height;
					}
				}	

			} else if (ev.offsetY == 1) {
				
				_totalForSwipe = 3;
				
				while (cont_sp.numChildren > 0) {
					cont_sp.removeChildAt(0);
				}
				
				for (var h:int = 0; h < _results.length; h++){	
					var res:MyRecipes = new MyRecipes(_results[h], _userID);
					res.name = "rec" + h;
					cont_sp.addChild(res);
				}
				resizeHandler();
			}
		}
		
		
		/**
		* This method uses recipes depends on Screen.
		*/
		protected function goBack(ev:MouseEvent):void {
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_RECIPEBOOK);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method shows help.
		*/
		protected function showHelp(ev:MouseEvent):void {	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			backBt_sp.removeEventListener(MouseEvent.CLICK, goBack);
			stage.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();		
		
			cont_sp.x =  stageW/2 - cont_sp.width/2;
			cont_sp.y = topBarH;
			
			var posY:int = 0;

			for (var i:int = 0; i < _results.length; i++){
				cont_sp.getChildByName("rec" + i).y = posY;
				cont_sp.getChildByName("rec" + i).x = 0;
				posY += cont_sp.getChildByName("rec" + i).height;
			}

			if (_state == true) {
				helpBt_sp.x = stageW - GUTTERH;
				helpBt_sp.y = stageH - GUTTERH;
			}
		}
	}
}

