package spujol.tfg.sp.screens.app
{	
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.utils.ByteArray;

	import flash.events.Event;
	import flash.events.MouseEvent;

	import flash.net.SharedObject;
	
	import spujol.tfg.sp.ui.bt.AppHelpIcon;
	import spujol.tfg.sp.ui.tab.AppNewRecipeTab;
	
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	

	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenNewRecipe extends ScreenTopBar
	{
		public var backBt_sp:Sprite;
		public var helpBt_sp:AppHelpIcon;
		public var tab_sp:AppNewRecipeTab;
		public var bgForm_sp:Sprite;
		
		
		protected var sharedObjectRecipe:SharedObject
		protected var _size:Number;
		
		protected var _arrayIng:Array = null;
		protected var _arrayRec:Array = null;
		protected var _arrayPre:Array = null;
		protected var _arrayDat:Array = null;
		protected var _arrayBmp:ByteArray;
		protected var _original:String = "";
		
		protected var _tabType:String;
		protected var _name:String;
		protected var _state:Boolean;
		
		protected var tabH:int;
		
		public function ScreenNewRecipe() 
		{		
			getDataSO();
			if (_size == 0) {		
				_arrayIng = new Array();
				_arrayPre = new Array();
				_arrayDat = new Array();	
				_arrayRec = new Array();
			} else {
				if (_arrayIng == null) {_arrayIng = new Array();}
				if (_arrayPre == null) {_arrayPre = new Array();}
				if (_arrayDat == null) {_arrayDat = new Array();}
				if (_arrayRec == null) {_arrayRec = new Array();}
			}
			
			super();
		}
		
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			screenTitle_tf.text = "Nueva receta";
			
			tab_sp = new AppNewRecipeTab(_tabType);
			addChild(tab_sp);
			
			if (_state == true){
				helpBt_sp = new AppHelpIcon();
				addChild(helpBt_sp);
				// Eventlisteners
				helpBt_sp.addEventListener(MouseEvent.CLICK,showHelp);
			}
			
			// Change cursor on hover
			backBt_sp.buttonMode = true;
		
			// Unable click detection on internal instances
			backBt_sp.mouseChildren = false;
		
			//Listeners
			backBt_sp.addEventListener(MouseEvent.CLICK,goBack);
			tab_sp.tabI_sp.addEventListener(MouseEvent.CLICK,goToIngredients);
			tab_sp.tabP_sp.addEventListener(MouseEvent.CLICK,goToPreparation);
			tab_sp.tabD_sp.addEventListener(MouseEvent.CLICK,goToData);

			//Execute init from superclass
			super.init(ev)
		}
			
		
		/**
		* This method goes to ingredients.
		*/
		private function goToIngredients(ev:MouseEvent):void {
			setDataSO(_tabType);
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_NEWRECIPE_I);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method goes to preparation.
		*/
		private function goToPreparation(ev:MouseEvent):void {
			setDataSO(_tabType);
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_NEWRECIPE_P);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method goes to data.
		*/
		private function goToData(ev:MouseEvent):void {
			setDataSO(_tabType);
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_NEWRECIPE_D);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method goes screen back.
		*/
		private function goBack(ev:MouseEvent):void {
			setDataSO(_tabType);
	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPTWO);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method shows help.
		*/
		protected function showHelp(ev:MouseEvent):void {	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();			
			tab_sp.resizeTab(stageW);
			tab_sp.y = topBarH;
			tabH = tab_sp.height;
			
			bgForm_sp.x = 0;
			bgForm_sp.width = stageW;
			
			if (_state == true) {
				helpBt_sp.x = stageW - GUTTERH;
				helpBt_sp.y = stageH - GUTTERH;
			}
		}
	
		
		/**
		* This method sets data on Share Object
		*/
		protected function setDataSO(from:String):void{	
			sharedObjectRecipe = SharedObject.getLocal("newRecipe");
				
			if (from == "ingredients"){sharedObjectRecipe.data.ingredients = _arrayIng; }
			if (from == "ingredientsRecipe"){sharedObjectRecipe.data.recipes = _arrayRec;}	
			if (from == "preparation"){sharedObjectRecipe.data.preparation = _arrayPre;} 
			if (from == "recipeData"){sharedObjectRecipe.data.recipeData = _arrayDat; }
			if (from == "original"){sharedObjectRecipe.data.original = _original;}	
		
			sharedObjectRecipe.flush();
		}
		
		/**
		* This method gets data from Share Object
		*/
		protected function getDataSO():void{	
			sharedObjectRecipe = SharedObject.getLocal("newRecipe");
			
			_arrayIng = sharedObjectRecipe.data.ingredients;
			_arrayRec = sharedObjectRecipe.data.recipes;
			_arrayPre = sharedObjectRecipe.data.preparation;
			_arrayDat = sharedObjectRecipe.data.recipeData;
			_original = sharedObjectRecipe.data.original;
			_size = sharedObjectRecipe.size;
		}
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			backBt_sp.removeEventListener(MouseEvent.CLICK,goBack);
			tab_sp.tabI_sp.removeEventListener(MouseEvent.CLICK,goToIngredients);
			tab_sp.tabP_sp.removeEventListener(MouseEvent.CLICK,goToPreparation);
			tab_sp.tabD_sp.removeEventListener(MouseEvent.CLICK,goToData);

		}
	}
}