package spujol.tfg.sp.screens.app
{	
	import com.adobe.images.JPGEncoder;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.net.FileReference;
	import flash.text.TextField;
	import spujol.tfg.sp.ui.bt.AppSaveRecipe;
	import spujol.tfg.sp.ui.bt.AppTakeImg;
	

	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FocusEvent;
	import flash.events.TextEvent;
	import flash.events.ActivityEvent;
	import flash.events.StatusEvent;
	
	import flash.media.Camera;
	import flash.media.Video;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	import flash.system.Security;
	import flash.system.SecurityPanel;
	
	import spujol.tfg.sp.screens.app.ScreenNewRecipe;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	import spujol.tfg.sp.ui.form.InputBox;
	import spujol.tfg.sp.ui.form.InputDropList;
	
	import spujol.tfg.sp.ui.bt.AppLargeBt;
	import spujol.tfg.sp.ui.bt.AppShortBt;
	
	import spujol.tfg.sp.preloader.Preloader;
	
	import spujol.tfg.sp.api.DBsetAPI;
	import spujol.tfg.sp.api.IMGFileAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	

	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenNewRecipe_D extends ScreenNewRecipe
	{		
		public var nameInput_sp:InputBox;
		public var collectionInput_sp:InputDropList;
		public var portionInput_sp:InputDropList;
		public var valueInput_sp:InputDropList;
		public var privacityInput_sp:InputDropList;
		
		public var preloader:Preloader;
		
		public var agregarImgBt_sp:AppTakeImg;
		public var guardarBt_sp:AppSaveRecipe;
		public var error_tf:TextField;
		private var _imgAPI:IMGFileAPI;
		private var _dbAPI:DBsetAPI;
		private var _collectionsArray:Array; 
		private var _rationArray:Array; 
		private var _valueArray:Array; 
		private var _privacityArray:Array; 
				
		public function ScreenNewRecipe_D (state:Boolean, name:String,  arrayData:Array) 
		{
			_name = name;
			_state = state;
			_tabType = "recipeData";
			
			_collectionsArray = arrayData[2];
			_rationArray =  new Array("2", "4", "6");
			_valueArray =  new Array("BAJO", "MEDIO", "ALTO");
			_privacityArray = new Array("PRIVADA", "PUBLICA");
			
			super();
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
		
			if (!_arrayDat[0]) { nameInput_sp = new InputBox("Nombre de la receta");	
			} else { nameInput_sp = new InputBox(_arrayDat[0], null, true);}
			
			if (!_arrayDat[1]) { collectionInput_sp  = new InputDropList("Colección", _collectionsArray);
			} else { collectionInput_sp  = new InputDropList(_arrayDat[1], _collectionsArray, false,  "", true);}
				
			if (!_arrayDat[2]) {portionInput_sp  = new InputDropList("Número de raciones", _rationArray, true, "Indica la cantidad deseada");
			} else {portionInput_sp  = new InputDropList(_arrayDat[2], _rationArray, true, "Indica la cantidad deseada", true);}
				
			if (!_arrayDat[3]) {valueInput_sp  = new InputDropList("Valor energético", _valueArray);
			} else { valueInput_sp  = new InputDropList(_arrayDat[3], _valueArray, false, "", true);}
				
			if (!_arrayDat[4]) { privacityInput_sp  = new InputDropList("Tipo de privacidad", _privacityArray);
			} else { privacityInput_sp  = new InputDropList(_arrayDat[4], _privacityArray, false, "", true);}

			portionInput_sp.inputBoxText_tf.restrict = "0-9";
			
			addChild(nameInput_sp);
			addChild(privacityInput_sp);
			addChild(valueInput_sp);
			addChild(portionInput_sp);
			addChild(collectionInput_sp);
			
			agregarImgBt_sp = new AppTakeImg();
			guardarBt_sp = new AppSaveRecipe();
			
			addChild(agregarImgBt_sp);
			addChild(guardarBt_sp);
			
			// Eventlisteners
			agregarImgBt_sp.addEventListener(MouseEvent.CLICK, veryfingCamera);
			guardarBt_sp.addEventListener(MouseEvent.CLICK, validateData);
			
			nameInput_sp.addEventListener(FocusEvent.FOCUS_OUT, saveName);
			collectionInput_sp.container_tf.addEventListener(TextEvent.LINK, saveCollection);
			portionInput_sp.container_tf.addEventListener(TextEvent.LINK, savePortion);
			portionInput_sp.addEventListener(FocusEvent.FOCUS_OUT, savePortion2);
			valueInput_sp.container_tf.addEventListener(TextEvent.LINK, saveValue);
			privacityInput_sp.container_tf.addEventListener(TextEvent.LINK, savePrivacity);

			//Execute init from superclass
			super.init(ev)
		}
		
		/**
		* These functions save recipe data into an object
		**/
		private function saveName(ev:FocusEvent):void{ _arrayDat[0] = nameInput_sp.inputBoxText_tf.text.toUpperCase();}
		private function saveCollection(ev:TextEvent):void{ _arrayDat[1] = ev.text;}
		private function savePortion(ev:TextEvent):void{_arrayDat[2] = ev.text;}
		private function savePortion2(ev:FocusEvent):void{ _arrayDat[2] = portionInput_sp.inputBoxText_tf.text.toUpperCase();}
		private function saveValue(ev:TextEvent):void{ _arrayDat[3] = ev.text;}
		private function savePrivacity(ev:TextEvent):void{ _arrayDat[4]  = ev.text;}
		
		
		/**
		* This method Verifyies that cameras are installed.
		*/
		private function veryfingCamera(ev:MouseEvent):void{
			var rectangle:Sprite;
			var vid:Video;
			var camBt_sp:AppLargeBt;
			var _cam:Camera;
			var bmd:BitmapData;
			var bm:Bitmap;
			var ok:AppShortBt;
			var no:AppShortBt;
			var cancel:AppLargeBt;
			var cancel1:AppLargeBt;
			
			if (Camera.names.length > 0) { 
				trace("User has at least one camera installed."); 
				
				_cam = Camera.getCamera(); // Get default camera. 
				_cam.setMode(480, 360, 24);
				
				
				if (_cam != null){ 
					_cam.addEventListener(StatusEvent.STATUS, statusHandler); //Detecting permissions for camera access
					putCam();
				}
				
				
				
			} else { trace("User has no cameras installed.");}
			
		
			function putCam():void {
				rectangle = new Sprite();
				rectangle.graphics.beginFill(0xC9D5E5); //(0xA2B2C8);
				var recW:int = stageW;
				var recH:int = stageH;
				rectangle.graphics.drawRect(0, 0, recW, recH);

				vid = new Video();
				vid.width = _cam.width;
				vid.height = _cam.height; 
				vid.x = stageW/2 - _cam.width/2;
				vid.y = stageH/2 - _cam.height;
				vid.attachCamera(_cam); 
						
				camBt_sp = new AppLargeBt("Capturar imagen");
				camBt_sp.x = stageW/2 - camBt_sp.width/2;
				camBt_sp.y = stageH/2 + 100;
				camBt_sp.addEventListener(MouseEvent.CLICK, takeImg);
				
				cancel1 = new AppLargeBt ("Cancelar");
				cancel1.x = stageW / 2 - cancel1.width / 2;
				cancel1.y = camBt_sp.y + cancel1.height * 2
				cancel1. addEventListener(MouseEvent.CLICK, canelImg1);
						
				addChild(rectangle);
				rectangle.addChild(vid);
				rectangle.addChild(camBt_sp);
				rectangle.addChild(cancel1);
			}
			
			function canelImg1(ev:MouseEvent):void {
				removeChild(rectangle);
				camBt_sp.removeEventListener(MouseEvent.CLICK, takeImg);
				rectangle.removeChild(vid);
				rectangle.removeChild(camBt_sp);
				
			}
			
			function takeImg(ev:MouseEvent):void {
				bmd = new BitmapData(480, 360);
                bm = new Bitmap(bmd);
				_cam.drawToBitmapData(bmd);
				
				bm.x = stageW/2 - _cam.width/2;
                bm.y = stageH/2 - _cam.height;
				
				camBt_sp.removeEventListener(MouseEvent.CLICK, takeImg);
				rectangle.removeChild(vid);
				rectangle.removeChild(camBt_sp);
				
				
				ok = new AppShortBt("Guardar");
				ok.addEventListener(MouseEvent.CLICK, saveImg);
				ok.x = stageW/2 - ok.width-30;
				ok.y = stageH/2 + 100;
				no = new AppShortBt("Repetir");
				no.x = stageW/2 +30;
				no.y = stageH/2 + 100;
				no.addEventListener(MouseEvent.CLICK, reDo);
				cancel = new AppLargeBt ("Cancelar");
				cancel.x = stageW / 2 - cancel.width / 2;
				cancel.y = no.y + cancel.height * 2
				cancel. addEventListener(MouseEvent.CLICK, canelImg);
				
				rectangle.addChild(bm);
				rectangle.addChild(ok);
				rectangle.addChild(no);
				rectangle.addChild(cancel);
			}
			
			function reDo(ev:MouseEvent):void {
				
				rectangle.removeChild(ok);
				rectangle.removeChild(no);
				rectangle.removeChild(bm);
				removeChild(rectangle);
				
				putCam();
			}
			
			function saveImg(ev:MouseEvent):void {
				var jpgEncoder:JPGEncoder = new JPGEncoder(50);
				var byte:ByteArray = jpgEncoder.encode(bmd);
				
				_arrayBmp  = byte;
				

				removeChild(rectangle);
				
				camBt_sp.removeEventListener(MouseEvent.CLICK, takeImg);
				ok.removeEventListener(MouseEvent.CLICK, saveImg);
				no.removeEventListener(MouseEvent.CLICK, reDo);
				cancel. removeEventListener(MouseEvent.CLICK, canelImg);
				
			}
			
			
			function canelImg(ev:MouseEvent):void {
				
				removeChild(rectangle);
				
				camBt_sp.removeEventListener(MouseEvent.CLICK, takeImg);
				ok.removeEventListener(MouseEvent.CLICK, saveImg);
				no.removeEventListener(MouseEvent.CLICK, reDo);
				cancel. removeEventListener(MouseEvent.CLICK, canelImg);
				
			}
			
			function statusHandler(event:StatusEvent):void { 
			// This event gets dispatched when the user clicks the "Allow" or "Deny" 
			// button in the Flash Player Settings dialog box. 
			trace(event.code); // "Camera.Muted" or "Camera.Unmuted" 
			switch (event.code) 
			{ 
				case "Camera.Muted": 
					trace("User clicked Deny."); 
					// Security.showSettings(SecurityPanel.CAMERA);
					break; 
				case "Camera.Unmuted": 
					trace("User clicked Accept."); 
					// putCam();
					break; 
			} 
		}
		
			
		}

		
 
		
		
		
		private function validateData(ev:MouseEvent):void{
			var msg:String = "";

			if (_arrayIng.length == 0) { msg = "Debes introducir los ingredientes necesarios";}
			else if (_arrayPre.length == 0) { msg = "Debes indicar el procedimiento a seguir";}
			else if (_arrayDat.length == 0) { msg = "Debes indicar los datos de la receta";}
			else if (!_arrayDat[0]) { 
				msg = "Debes indicar un nombre";
				stage.focus = nameInput_sp;}
			else if (!_arrayDat[1]) { 
				msg = "Debes seleccionar una colección.";
				stage.focus = collectionInput_sp;}
			else if ((!_arrayDat[2])||(_arrayDat[2] == "Indica la cantidad deseada")) { 
				msg = "Debes indicar el número de raciones";
				stage.focus = portionInput_sp;}
			else if (!_arrayDat[3]) { 
				msg = "Debes seleccionar el valor energético";
				stage.focus = valueInput_sp;}
			else if (!_arrayDat[4]) { 
				msg = "Debes seleccionar la privacidad";
				stage.focus = privacityInput_sp;}
			else {
				_arrayDat[0] = nameInput_sp.inputBoxText_tf.text.toUpperCase();
				_arrayDat[1] = collectionInput_sp.inputBoxText_tf.text.toUpperCase();
				_arrayDat[2] = portionInput_sp.inputBoxText_tf.text.toUpperCase();
				_arrayDat[3] = valueInput_sp.inputBoxText_tf.text;
				_arrayDat[4] = privacityInput_sp.inputBoxText_tf.text.toUpperCase();
				
				if (_arrayDat.length == 5){
					_arrayDat[5] = 0;
				}
				saveImgServer();
			}
			
			error_tf.text = msg;
			error_tf.height = error_tf.textHeight + 4;	
		}
		
		
		/**
		* This method saves img on Server folder.
		*/
		private function saveImgServer():void{
			if (_arrayBmp != null){
				_imgAPI = new IMGFileAPI();
				_imgAPI.loadIMG(_arrayBmp);
				_imgAPI.addEventListener(DBAPIEvent.COMPLETE, saveInDBWithImg);
			} else {
				saveInDB ();
			}
			
			
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);
		}
		
		
		/**
		* This method saves data on database an puts a preloader on the screen.
		*/
		private function saveInDBWithImg(ev:DBAPIEvent):void{	
			var imgURLArray:Array = ev.data;
			var imgURL:String = imgURLArray[0];
			var thumbURL:String = imgURLArray[1];
			
			_dbAPI = new DBsetAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, saveMessage);
			_dbAPI.loadNewRecipe("newRecipe", _arrayIng, _arrayRec, _arrayPre, _arrayDat, _name, _original, imgURL, thumbURL);	

		}
		
		
		/**
		* This method saves data on database an puts a preloader on the screen.
		*/
		private function saveInDB():void{			
			_dbAPI = new DBsetAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, saveMessage);
			_dbAPI.loadNewRecipe("newRecipe", _arrayIng, _arrayRec, _arrayPre, _arrayDat, _name, _original, _arrayDat[7],_arrayDat[6]);	
		}
		
		
		/**
		* This method goes screen back.
		*/
		private function saveMessage(ev:DBAPIEvent):void {
			removeChild(preloader);
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPONE);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			agregarImgBt_sp.removeEventListener(MouseEvent.CLICK, veryfingCamera);
			guardarBt_sp.removeEventListener(MouseEvent.CLICK, saveInDB);
		}
		
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			
			bgForm_sp.y = topBarH + tabH;
			bgForm_sp. height = stageH - bgForm_sp.y;
			
			
			nameInput_sp.x = stageW/2 - nameInput_sp.width/2;
			collectionInput_sp.x = stageW/2 - collectionInput_sp.width/2;
			portionInput_sp.x = stageW/2 - portionInput_sp.width/2;
			valueInput_sp.x = stageW/2 - valueInput_sp.width/2;
			privacityInput_sp.x = stageW/2 - privacityInput_sp.width/2;
			agregarImgBt_sp.x = stageW/2 - agregarImgBt_sp.width/2;
			guardarBt_sp.x = stageW/2 - guardarBt_sp.width/2;
			error_tf.x = stageW/2 - error_tf.width/2;
			
			var MES:int = nameInput_sp.height*2;
			nameInput_sp.y = bgForm_sp.y + nameInput_sp.height;;
			collectionInput_sp.y = nameInput_sp.y + MES;
			portionInput_sp.y = collectionInput_sp.y + MES;
			valueInput_sp.y = portionInput_sp.y + MES;
			privacityInput_sp.y = valueInput_sp.y + MES;
			agregarImgBt_sp.y = privacityInput_sp.y + MES;
			guardarBt_sp.y = agregarImgBt_sp.y + MES;
			error_tf.y = guardarBt_sp.y + MES;
			
			
		}
	}
}