package spujol.tfg.sp.screens.app
{	
	import flash.display.Sprite;
	import flash.text.TextField;
	import spujol.tfg.sp.instances.NewRecipeRecipe;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TransformGestureEvent;
	
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	
	import spujol.tfg.sp.ui.bt.AppSearchBt;
	import spujol.tfg.sp.ui.bt.AppLargeBt;
	
	import spujol.tfg.sp.screens.app.ScreenNewRecipe;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	import spujol.tfg.sp.ui.form.InputBox;
	import spujol.tfg.sp.ui.form.InputDropList;
	import spujol.tfg.sp.instances.NewRecipeIngredient;
	
	import spujol.tfg.sp.api.DBsetAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenNewRecipe_I extends ScreenNewRecipe
	{		
		public var addReceipt_tf:TextField;
		public var contIng_sp:Sprite;
		public var searchBt_sp:AppSearchBt;
		public var addIngredientBt_sp:AppLargeBt;
		
		public var ingredientInput_sp:InputBox;
		public var measureInput_sp:InputDropList;
		public var quantityInput_sp:InputBox;

		private var _ingredientsArray:Array = null;  
		private var _measuresArray:Array = null; 

		private var _ing:NewRecipeIngredient;
		private var _newArray:Array = null; 
		private var _dbAPI:DBsetAPI;
		private var _recipe:Object = new Object; 
		private var _recipeModify:Object = new Object;
		private var _recipeAuthorModify:Object = new Object;
		private var _arg:int;
		private var _totalForSwipe:int = -3;

		public function ScreenNewRecipe_I(state:Boolean, name:String, arrayData:Array, recipe:Object = null, recipeModify:Object = null, recipeAuthorModify:Object = null) 
		{
			super();
			
			_name = name;
			_state = state;
			_tabType = "ingredients";
			
			_ingredientsArray = arrayData[0];
			_measuresArray = arrayData[1];
			_recipe = recipe;
			_recipeModify = recipeModify;
			_recipeAuthorModify = recipeAuthorModify;
			
			_arg = arguments.length;
		}
		
	
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			searchBt_sp = new AppSearchBt;
			addChild(searchBt_sp);
			addIngredientBt_sp = new AppLargeBt("Agregar ingrediente");
			addChild(addIngredientBt_sp);
			
			ingredientInput_sp = new InputBox("Ingrediente", _ingredientsArray);
			quantityInput_sp = new InputBox("Cantidad (numérica)", null);
			quantityInput_sp.inputBoxText_tf.restrict = "0-9,.";
			measureInput_sp = new InputDropList("Unidad de medida", _measuresArray, true, "Indica la unidad deseada");
			
			addChild(measureInput_sp);
			addChild(quantityInput_sp);
			addChild(ingredientInput_sp);
			
			if (_arg == 3){
			_original = "null";
			setDataSO("original");
			}
			if (_arg == 4) {
				addRecipe(_recipe);
			} 
			if (_arg == 5) { 
				_arrayIng = _recipeModify.ingredients;
				_arrayRec = _recipeModify.reused;
				_arrayPre = _recipeModify.procediments;
				_original = _recipeModify.original;
			
				setDataSO("ingredients");	
				setDataSO("ingredientsRecipe");	
				setDataSO("preparation");
				setDataSO("original");
			}
			
			if (_arg == 6) { 
				_arrayIng = _recipeAuthorModify.ingredients;
				_arrayRec = _recipeAuthorModify.reused;
				_arrayPre = _recipeAuthorModify.procediments;
				
				
				var object:Object =_recipeAuthorModify.recipe; 
				_arrayDat[0] = object.name;
				_arrayDat[1] = object.collection;
				_arrayDat[2] = object.pax;
				_arrayDat[3] = object.value;
				_arrayDat[4] = object.privacity;	
				_arrayDat[5] = object.id; 
				_arrayDat[6] = object.thumb;
				_arrayDat[7] = object.img;
				
				_original = "original";
				
				setDataSO("ingredients");	
				setDataSO("ingredientsRecipe");	
				setDataSO("preparation");
				setDataSO("original");
				setDataSO("recipeData");
				
			}
		
			searchBt_sp.addEventListener(MouseEvent.CLICK,goToSearchRecipe);
			addIngredientBt_sp.addEventListener(MouseEvent.CLICK, validateInputs);
			
			// sobre moviments tàctils
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			//Execute init from superclass
			super.init(ev);
			showNewList();
		}
		
		
		
		/**
		* This method controls scroll tactil events.
		*/
		private function onSwipe(ev:TransformGestureEvent):void{
			if (ev.offsetY == -1) {
				
				var arrayCopy:Array = _arrayIng.slice(0, _totalForSwipe);
				var total:int = arrayCopy.length;
				var i:int = total-1;
								
				if (total > 0){
					
					while (contIng_sp.numChildren > 0) {
					contIng_sp.removeChildAt(0);
					}
					while (i >= 0){
						var ing:NewRecipeIngredient = new NewRecipeIngredient(arrayCopy[i]);
						ing.name = "ing" + i;
						ing.deleteBt_sp.addEventListener(MouseEvent.CLICK, deleteIngredientFromArray);
						contIng_sp.addChild(ing);					
						i--;					
					}		
				}
				
				_totalForSwipe -= 3;
				
				var posY:int = 0;
				var j:int = arrayCopy.length-1;
			
				contIng_sp.x = stageW/2 - contIng_sp.width/2;
				contIng_sp.y = bgForm_sp.y + bgForm_sp.height;
				
				if (contIng_sp.numChildren > 0){	

					for ( j = 0; j < contIng_sp.numChildren; j++){
						contIng_sp.getChildAt(j).x = 0;
						contIng_sp.getChildAt(j).y = posY;
						posY += contIng_sp.getChildAt(j).height;
					}
				}	
			
			
			} else if (ev.offsetY == 1) {
				_totalForSwipe = -3;
				showNewList();
			}
		}

		
		
		/**
		* This method changes screen to ScreenSearchRecipe.
		*/
		private function goToSearchRecipe(ev:MouseEvent):void {
			setDataSO(_tabType);			
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_SEARCHRECIPE);
			dispatchEvent(screenEv);
			
		}
		
		
		/**
		* This method validates screen inputs.
		*/
		private function validateInputs(ev:MouseEvent){
			
			if ((ingredientInput_sp.inputBoxText_tf.text == "Ingrediente") || (ingredientInput_sp.inputBoxText_tf.text == "")) {
				stage.focus = ingredientInput_sp.inputBoxText_tf;
				ingredientInput_sp.inputBoxText_tf.text == "";
				
			} else if ((measureInput_sp.inputBoxText_tf.text == "Unidad de medida") || (measureInput_sp.inputBoxText_tf.text == "") || (measureInput_sp.inputBoxText_tf.text == "Indica la unidad deseada")) {
				stage.focus = measureInput_sp.inputBoxText_tf;
				measureInput_sp.inputBoxText_tf.text == "";
			
			} else if ((quantityInput_sp.inputBoxText_tf.text == "Cantidad (número)") || (quantityInput_sp.inputBoxText_tf.text == "")) {
				stage.focus = quantityInput_sp.inputBoxText_tf;
				quantityInput_sp.inputBoxText_tf.text == "";
			
			} else {
				
				ingredientInput_sp.inputBoxText_tf.text = ingredientInput_sp.inputBoxText_tf.text.toUpperCase();
				measureInput_sp.inputBoxText_tf.text = measureInput_sp.inputBoxText_tf.text.toUpperCase();
				
				var ingredient:String = ingredientInput_sp.inputBoxText_tf.text;
				var measure:String = measureInput_sp.inputBoxText_tf.text;
				
				var findIngredient:int;
				var findMeasure:int;
				
				findIngredient = _ingredientsArray.indexOf(ingredient);
				findMeasure = _measuresArray.indexOf(measure);
				
				var table:String;
				var element:String;
				
				if ((findIngredient == -1) && (findMeasure != -1)){ 
					createNewElement("ingredient", ingredient);
										
				}else if ((findMeasure == -1) && (findIngredient != -1)){ 
					createNewElement("measure", measure);
									
				} else if  ((findIngredient == -1) && (findMeasure == -1)){
					createTwoNewsElements(ingredient, measure);

				} else {
					addIngredient(ingredientInput_sp.inputBoxText_tf.text, measureInput_sp.inputBoxText_tf.text);
				}
				
			}
		}
		
		
		/**
		* This method creates new element into database.
		*/
		private function createNewElement(table:String, element:String){
			_dbAPI = new DBsetAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, response);
			_dbAPI.loadNewElements("newRecipeOneNew", table, element);
		}
		
		
		/**
		* This method creates two elements into database.
		*/
		private function createTwoNewsElements(ingredient:String, measure:String){
			_dbAPI = new DBsetAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, responseTwo);
			_dbAPI.loadNewElements("newRecipeTwoNew", ingredient, measure);
		}
		
		
		/**
		* This method adds ingredient when like is saved in databse.
		*/
		private function response(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			if (data[0] == "ingredient") { addIngredient(data[1], measureInput_sp.inputBoxText_tf.text);}
			else if (data[0] == "measure") { addIngredient(ingredientInput_sp.inputBoxText_tf.text, data[1]);}
		}
		
		
		/**
		* This method adds ingredient and measure like are saved in databse.
		*/
		private function responseTwo(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			addIngredient(data[0], data[1])
		}
		
		
		
		/**
		* This method adds a new object ingredient into array.
		*/
		private function addIngredient(ingr:String, meas:String):void {
			
			var object:Object= {
					ingredient: ingr, //ingredientInput_sp.inputBoxText_tf.text,
					quantity:quantityInput_sp.inputBoxText_tf.text,
					measure: meas //measureInput_sp.inputBoxText_tf.text
				};
		
			_arrayIng.push(object);		
			showNewList();
		}
		
		/**
		* This method adds a reused recipe into array.
		*/
		private function addRecipe(object:Object):void {		
			_arrayRec.push(object);	
			setDataSO("ingredientsRecipe");
		}
		
		
		/**
		* This method delets the object ingredient from array list.
		*/
		private function deleteIngredientFromArray(ev:MouseEvent){		
			var result:String = ev.target.parent.name;
			var index:Array = result.split("ing");
			var pos:int = int(index[1]);
			
			_arrayIng.removeAt(pos);
			showNewList();	
		}
		
		
		/**
		* This method delets the object recipe from array list.
		*/
		private function deleteRecipeFromArray(ev:MouseEvent){
			var result:String = ev.target.parent.name;
			var index:Array = result.split("rec");
			var pos:int = int(index[1]);
			
			_arrayRec.removeAt(pos);
			setDataSO("ingredientsRecipe");
			showNewList();	
		}
		
		
		
		
		/**
		* This method shows the list with changes.
		*/
		private function showNewList():void {
			while (contIng_sp.numChildren > 0) {
				contIng_sp.removeChildAt(0);
			}
			putRecipes();
			putIngredients();
			clearInputs();
			
			resizeHandler();
		}
		
		
		/**
		* This method puts array ingredients in the screen list.
		*/
		private function putIngredients(){
			var total:int = _arrayIng.length;
			var i:int = total-1;
								
			if (total > 0){
				while (i >= 0){
					var ing:NewRecipeIngredient = new NewRecipeIngredient(_arrayIng[i]);
					ing.name = "ing" + i;
					ing.deleteBt_sp.addEventListener(MouseEvent.CLICK, deleteIngredientFromArray);
					contIng_sp.addChild(ing);					
					i--;
				}
			}
		}
		
		
		/**
		* This method puts array recipes in the screen list.
		*/
		private function putRecipes(){
			var total:int = _arrayRec.length;
			if (total > 0){
				for (var i:int = 0; i < total; i++){
					var rec:NewRecipeRecipe = new NewRecipeRecipe(_arrayRec[i]);
					rec.name = "rec" + i;
					rec.deleteBt_sp.addEventListener(MouseEvent.CLICK, deleteRecipeFromArray);
					contIng_sp.addChild(rec);
				}
			}	
		}

		
		/**
		* This method clears screen inputs
		*/
		private function clearInputs(){
			ingredientInput_sp.clearInput();
			measureInput_sp.clearInput();
			quantityInput_sp.clearInput();
		} 
		
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			searchBt_sp.removeEventListener(MouseEvent.CLICK,goToSearchRecipe);
			addIngredientBt_sp.removeEventListener(MouseEvent.CLICK,validateInputs);
			stage.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
		}
		
		
		
		/**
		* This override method adapts ingredients.
		*/
		private function resizeIngredients():void {
			var posY:int = 0;
			var i:int;
			
			contIng_sp.x = stageW/2 - contIng_sp.width/2;
			contIng_sp.y = bgForm_sp.y + bgForm_sp.height;

			if (contIng_sp.numChildren > 0){	

				for ( i = 0; i < contIng_sp.numChildren; i++){
					contIng_sp.getChildAt(i).x = 0;
					contIng_sp.getChildAt(i).y = posY;
					posY += 50;
				
				}
			}
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event= null):void {
			super.resizeHandler();
			bgForm_sp.y = topBarH + tabH + GUTTERH;
			bgForm_sp. height = ingredientInput_sp.height*6;
			
			addReceipt_tf.x = stageW/2 - addReceipt_tf.width;
			addReceipt_tf.y = topBarH + tabH + GUTTERH/2 - addReceipt_tf.height/2;
			searchBt_sp.x = stageW/2;
			searchBt_sp.y = topBarH + tabH + GUTTERH/2 - searchBt_sp.height/2;
			
			var MES:int = (ingredientInput_sp.height*2)/1.5;
			ingredientInput_sp.x =  stageW/2 -ingredientInput_sp.width/2;
			ingredientInput_sp.y = bgForm_sp.y + ingredientInput_sp.height/2;
			quantityInput_sp.x =  stageW/2 -ingredientInput_sp.width/2;
			quantityInput_sp.y = ingredientInput_sp.y + MES;
			measureInput_sp.x =  stageW/2 -ingredientInput_sp.width/2;
			measureInput_sp.y = quantityInput_sp.y + MES;
			
			addIngredientBt_sp.x =  stageW/2 -addIngredientBt_sp.width/2;
			addIngredientBt_sp.y = measureInput_sp.y + MES;

			resizeIngredients();	
		}
	}
}