package spujol.tfg.sp.screens.app
{	
	import flash.display.Sprite;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TransformGestureEvent;
	
	import flash.text.TextFieldAutoSize;
	
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	
	import spujol.tfg.sp.ui.bt.AppLargeBt;
	import spujol.tfg.sp.ui.bt.AppShortBt;
	import spujol.tfg.sp.instances.NewRecipePreparation;
	import spujol.tfg.sp.ui.form.InputTextBox;
	
	import spujol.tfg.sp.screens.app.ScreenNewRecipe;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	

	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenNewRecipe_P extends ScreenNewRecipe
	{	
		public var addPointBt_sp:AppLargeBt;
		public var saveBt_sp:AppShortBt;
		public var cancelBt_sp:AppShortBt;
		public var pointBox_sp:InputTextBox;
		public var contPoints_sp:Sprite;
		private var _totalForSwipe:int = -3;
		
		public function ScreenNewRecipe_P(state:Boolean, name:String) 
		{		
			super();
			
			_name = name;
			_state = state;
			_tabType = "preparation";
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			addPointBt_sp = new AppLargeBt("Agregar instrucción");
			addChild(addPointBt_sp);
			
			pointBox_sp = new InputTextBox("Editar instrucción ...");
			addChild(pointBox_sp);
			
			addPointBt_sp.addEventListener(MouseEvent.CLICK, validateInputs);
			
			// sobre moviments tàctils
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			setChildIndex(getChildByName("contPoints_sp"), 1);
			
			putInstructions(true);
			
			//Execute init from superclass
			super.init(ev)
		}
		
		/**
		* This method controls scroll tactil events.
		*/
		private function onSwipe(ev:TransformGestureEvent):void{
			
			if (ev.offsetY == -1) {
				deleteList();
				var arrayCopy:Array = _arrayPre.slice(0, _totalForSwipe);
				var total:int = arrayCopy.length;
				var i:int = total-1;
								
				if (total > 0){
					while (i >= 0){
						arrayCopy[i].name = "pre" + i;
						arrayCopy[i].number = i +1;
						var pre:NewRecipePreparation = new NewRecipePreparation(arrayCopy[i]);
						pre.name = "pre" + i;

						pre.deleteBt_sp.addEventListener(MouseEvent.CLICK, deleteInstructionFromArray);
						pre.edit_sp.addEventListener(MouseEvent.CLICK, editInstruction);	
						
						contPoints_sp.addChild(pre);					
						i--;
					}		
				}
				_totalForSwipe -= 3;
				
				var posY:int = 0;
				var j:int = arrayCopy.length-1;
			
				contPoints_sp.x = stageW/2 - contPoints_sp.width/2;
				contPoints_sp.y = bgForm_sp.y + bgForm_sp.height -2;
				
				if (contPoints_sp.numChildren > 0){
									
				if (arrayCopy.length > 0){
					while (j >= 0){
						contPoints_sp.getChildByName("pre" + j).x = 0;
						contPoints_sp.getChildByName("pre" + j).y = posY;	
						posY += contPoints_sp.getChildByName("pre" + j).height + 4;
						j--;
						}
					}
				}
					
				
			} else if (ev.offsetY == 1) {
				_totalForSwipe = -3;

				deleteList();
				putInstructions(true);
			}
		}
				
		
		
		/**
		* This method validates screen inputs.
		*/
		private function validateInputs(ev:MouseEvent){
			
			if ((pointBox_sp.inputBoxText_tf.text == "Editar instrucción ...") || (pointBox_sp.inputBoxText_tf.text == "")) {
				stage.focus = pointBox_sp.inputBoxText_tf;
				pointBox_sp.inputBoxText_tf.text == "";
				
			} else {
				
				var instructionText:String = pointBox_sp.inputBoxText_tf.text.toUpperCase();
				addPoint(instructionText);
			}
		}
		
		
		/**
		* This puts edit point in the screen.
		*/
		private function addPoint(text:String){
						
				var object:Object= {
					number:0, //_arrayPre.length +1,
					text:text
				};
		
			_arrayPre.push(object);	
			
			deleteList();
			putInstructions(true);
			pointBox_sp.clearInput();	
		}
		
		
		/**
		* This method deletes screen list.
		*/
		private function deleteList():void {
			while (contPoints_sp.numChildren > 0) {
				contPoints_sp.removeChildAt(0);
			}
		}
		
		
		/**
		* This method puts array ingredients in the screen list.
		*/
		private function putInstructions(stage:Boolean){
			var total:int = _arrayPre.length;
			var posY:int = 0;
			var i:int = total-1;
								
			if (total > 0){
				while (i >= 0){
					_arrayPre[i].name = "pre" + i;
					_arrayPre[i].number = i +1;
					var pre:NewRecipePreparation = new NewRecipePreparation(_arrayPre[i]);
					pre.name = "pre" + i;

					if (stage  == true) {
					pre.deleteBt_sp.addEventListener(MouseEvent.CLICK, deleteInstructionFromArray);
					pre.edit_sp.addEventListener(MouseEvent.CLICK, editInstruction);
					}
					
					contPoints_sp.addChild(pre);					
					i--;
				}
			}
			resizeInstructions();
		}
		
		
		/**
		* This method delets the object ingredient from array list.
		*/
		private function editInstruction(ev:MouseEvent){
			var pos:int = 0;
			var total:int = _arrayPre.length;
				for (var i:int = 0; i < total; i++){
					if (_arrayPre[i].name == ev.target.parent.name){pos = i;}
				}	
			stage.focus = pointBox_sp.inputBoxText_tf;
			pointBox_sp.inputBoxText_tf.text = _arrayPre[pos].text;
			
			
			addPointBt_sp.removeEventListener(MouseEvent.CLICK, validateInputs);
			removeChild(addPointBt_sp);
			
			saveBt_sp = new AppShortBt("Guardar");
			saveBt_sp.addEventListener(MouseEvent.CLICK, saveChanges);	
			saveBt_sp.x = stageW/2 - saveBt_sp.width - 25;
			saveBt_sp.y = bgForm_sp.y + bgForm_sp.height - addPointBt_sp.height*1.5;
			addChild(saveBt_sp);
			cancelBt_sp = new AppShortBt("Cancelar");
			cancelBt_sp.addEventListener(MouseEvent.CLICK, returnNormal);
			cancelBt_sp.x = stageW/2 + 25;
			cancelBt_sp.y = bgForm_sp.y + bgForm_sp.height - addPointBt_sp.height*1.5;
			addChild(cancelBt_sp);
				
			deleteList();
			putInstructions(false);
		
			
			function saveChanges(ev:MouseEvent){	
				_arrayPre[pos].text = pointBox_sp.inputBoxText_tf.text.toUpperCase();;				
				returnNormal(null);

			}
			
			function returnNormal(ev:MouseEvent){
				addPointBt_sp = new AppLargeBt("Agregar instrucción");
				addPointBt_sp.addEventListener(MouseEvent.CLICK, validateInputs);
				addPointBt_sp.x = stageW/2 - addPointBt_sp.width/2;;
				addPointBt_sp.y = bgForm_sp.y + bgForm_sp.height - addPointBt_sp.height*1.5;
				addChild(addPointBt_sp);
				
				pointBox_sp.inputBoxText_tf.text= "Editar instrucción ...";
				
				saveBt_sp.removeEventListener(MouseEvent.CLICK, saveChanges);	
				cancelBt_sp.removeEventListener(MouseEvent.CLICK, returnNormal);
				removeChild(saveBt_sp);
				removeChild(cancelBt_sp);
				
				deleteList();
				putInstructions(true);
			}
		}
		

		/**
		* This method delets the object ingredient from array list.
		*/
		private function deleteInstructionFromArray(ev:MouseEvent){
			var pos:int = 0;
			var total:int = _arrayPre.length;
				for (var i:int = 0; i < total; i++){
					if (_arrayPre[i].name == ev.target.parent.name){pos = i;}
				}	

			_arrayPre.removeAt(pos);
			
			deleteList();
			putInstructions(true);
		}
		
		
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			addPointBt_sp.removeEventListener(MouseEvent.CLICK,addPoint);
			stage.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
		}
		
		
		/**
		* This override method adapts instructions.
		*/
		private function resizeInstructions():void {
			var posY:int = 0;
			var i:int = _arrayPre.length-1;
			
			contPoints_sp.x = stageW/2 - contPoints_sp.width/2;
			contPoints_sp.y = bgForm_sp.y + bgForm_sp.height -2;
			
			if (contPoints_sp.numChildren > 0){
								
			if (_arrayPre.length > 0){
				while (i >= 0){
					contPoints_sp.getChildByName("pre" + i).x = 0;
					contPoints_sp.getChildByName("pre" + i).y = posY;	
					posY += contPoints_sp.getChildByName("pre" + i).height + 4;
					i--;
					}
				}
			}
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			
			bgForm_sp.y = topBarH + tabH;
			bgForm_sp.height = pointBox_sp.height + addPointBt_sp.height+ GUTTERH/2;

			pointBox_sp.x = stageW/2 - pointBox_sp.width/2;
			pointBox_sp.y = bgForm_sp.y + (addPointBt_sp.height/2);
			
			addPointBt_sp.x = stageW/2 - addPointBt_sp.width/2;;
			addPointBt_sp.y = bgForm_sp.y + bgForm_sp.height - addPointBt_sp.height*1.5;

			resizeInstructions();
		}
	}
}