package spujol.tfg.sp.screens.app
{
	import flash.text.TextField;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.IOErrorEvent;
	
	import flash.net.URLRequest;
	import flash.net.URLLoader;

	import spujol.tfg.sp.ui.bt.AppCollectionBt;
	import spujol.tfg.sp.ui.bt.AppNewRecipeBt;
	import spujol.tfg.sp.ui.bt.AppSearchBt;
	import spujol.tfg.sp.ui.bt.AppHelpIcon;
	
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	

	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenRecipeBook extends ScreenTopBar
	{
		public var optionsBt_sp:Sprite;
		public var helpBt_sp:AppHelpIcon;
		public var closeBt_sp:Sprite;
		public var editBt_sp:AppNewRecipeBt;
		public var searchBt_sp:AppSearchBt;
		
		//public var calendarBtOff_sp:Sprite;
		//public var menuBtOff_sp:Sprite;
		//public var recipeBtOn_sp:Sprite;
		//public var bottomBarW_sp:Sprite;
		//public var bottomBarB_sp:Sprite;
		
		public var collectionCont_sp:Sprite; // Contenidor botons colleció
		private var _collections:Array;
		private var _collectionObjects:Array;
	
		private var	_state;
		private var	_id; 
		private var	_email;
		private var	_name;
		private var	_history;
		private var _screenBefore;
		private var _popUpText:String;
		
		private var _collectionItem:Object={
			name : "",
			title : "",
			icon : ""
			};
		

		
		public function ScreenRecipeBook(history:Array, state:Boolean, id:int, name:String, email:String) 
		{
			_history = history;
			_state = state;
			_id = id;
			_name = name;
			_email = email;
			_collections = new Array("MIS RECETAS", "FAVORITAS","ENTRANTES", "PRIMEROS", "SEGUNDOS", "POSTRES", "SALSAS", "MASAS DULCES", "MASAS SALADAS");
			super();
		}
		
		
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			
			screenTitle_tf.text = "Recetario";
			_collectionObjects = new Array();
			
			if (_state == true){
				helpBt_sp = new AppHelpIcon();
				addChild(helpBt_sp);
				// Eventlisteners
				helpBt_sp.addEventListener(MouseEvent.CLICK,showHelp);
			}
			
			createCollectionObjectsArray();
			setCollections();

			// Change cursor on hover
		//	calendarBtOff_sp.buttonMode = true;
		//	menuBtOff_sp.buttonMode = true;
			optionsBt_sp.buttonMode = true;
			closeBt_sp.buttonMode = true;
			
			// Unable click detection on internal instances
		//	calendarBtOff_sp.mouseChildren = false;
		//	menuBtOff_sp.mouseChildren = false;
			optionsBt_sp.mouseChildren = false;
			closeBt_sp.mouseChildren = false;

			//Listeners
		//	calendarBtOff_sp.addEventListener(MouseEvent.CLICK,goToCalendar);
		//	menuBtOff_sp.addEventListener(MouseEvent.CLICK,goToMenu);
			editBt_sp.addEventListener(MouseEvent.CLICK,goToNewRecipe);
			searchBt_sp.addEventListener(MouseEvent.CLICK,goToSearchRecipe);
			optionsBt_sp.addEventListener(MouseEvent.CLICK,goToOptions);
			closeBt_sp.addEventListener(MouseEvent.CLICK, closeApp);
			
			//Execute init from superclass
			super.init(ev);
			resizeHandler();
		}
		
		
		/**
		* This method creates an object Array.
		*/		
		private function closeApp(ev:MouseEvent):void{
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPTWO);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method creates an object Array.
		*/		
		private function createCollectionObjectsArray(){
			for (var i:int = 0; i < _collections.length; i++){	
				var collection:Object= {
					name: "",
					title:"",
					icon: ""
				};
				
				collection.name = "collection" + i;
				collection.title = _collections[i];
				collection.icon = i;
			
				_collectionObjects.push(collection);
			}
		}
			
		

		/**
		* This method puts collection buttons on the screen.
		*/
		private function setCollections():void{
			
			for (var j:int = 0; j < _collectionObjects.length; j++){
				
				var collectionItem:AppCollectionBt = new AppCollectionBt(_collectionObjects[j], _id);
				collectionItem.name = "col"+j;
				collectionCont_sp.addChild(collectionItem);
			}
		}
		
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			 
			optionsBt_sp.x = stageW - optionsBt_sp.width;
			
			//buttons
			editBt_sp.x = (stageW/2) - editBt_sp.width - 30;
			editBt_sp.y = topBarH + editBt_sp.height;
			searchBt_sp.x = (stageW/2)  + 30;
			searchBt_sp.y = topBarH + editBt_sp.height;
			
			//bottom bar
		//	bottomBarB_sp.width = stageW;
		//	bottomBarB_sp.y = stageH - bottomBarB_sp.height;
		//	bottomBarW_sp.width = calendarBtOff_sp.width*3 + 4;
		//	bottomBarW_sp.x = (stageW/2) - (bottomBarW_sp.width/2);
		//	bottomBarW_sp.y = stageH - bottomBarW_sp.height;
		//	calendarBtOff_sp.y = stageH - calendarBtOff_sp.height;
		//	calendarBtOff_sp.x = (stageW/2) - (menuBtOff_sp.width/2) - calendarBtOff_sp.width;
		//	menuBtOff_sp.y = stageH - menuBtOff_sp.height;
		//	menuBtOff_sp.x = (stageW/2) - (menuBtOff_sp.width/2)
		//	recipeBtOn_sp.y = stageH - recipeBtOn_sp.height;
		//	recipeBtOn_sp.x = (stageW/2) + (menuBtOff_sp.width/2);
			
			if (_state == true) {
				helpBt_sp.x = stageW - helpBt_sp.width - (helpBt_sp.width/2);
				helpBt_sp.y = stageH - helpBt_sp.width - (helpBt_sp.width/2);
				//helpBt_sp.y = stageH - bottomBarB_sp.height - helpBt_sp.width - (helpBt_sp.width/2);
			}
			
			// Collections			
			collectionCont_sp.x = 0;
			collectionCont_sp.y = topBarH + editBt_sp.height*3;

			
			var numColumns:int;
			var numLines:int;
			var separationW:int;
			var separationH:int;
			var itemH:int;
			var itemW:int;
			
			if( stageW > stageH) {
				// Landscape mode
				numColumns = 5;
				numLines = 2;
				
			} else {
				// Portrait mode
				numColumns = 3;
				numLines = 3;
			}

			itemH = 402;
			itemW = 324;
			
			separationW = (stageW - (itemW*numColumns)) / (numColumns+1);
			separationH = ((stageH-collectionCont_sp.y) - (itemH*numLines)) / (numLines+2);
			
			var i:int;
			var col:int;
			var line:int;
			var posX:int
			var posY:int

			posY = separationH;
			i = 0;
			
			while (i < _collectionObjects.length){
				for (line=0; line<numLines; line++){
					posX = separationW;
					for (col=0; col<numColumns ;col++){
						collectionCont_sp.getChildByName("col" + i).x= posX;
						collectionCont_sp.getChildByName("col" + i).y= posY;
						collectionCont_sp.getChildByName("col" + i).width = itemW;
						collectionCont_sp.getChildByName("col" + i).height = itemH;
						i++;
						posX = posX + separationW + itemW;
					}
					posY = posY + separationH + itemH;
					
				}
			}
		}
		
		
		/**
		* This method shows help.
		*/
		private function showHelp(ev:MouseEvent):void {	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method changes screen to ScreenCalendar.
		*//*
		private function goToCalendar(ev:MouseEvent):void {
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_CALENDAR);
			dispatchEvent(screenEv);
			
		}*/
		
		/**
		* This method changes screen to ScreenMenu.
		*//*
		private function goToMenu(ev:MouseEvent):void {
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_MENU);
			dispatchEvent(screenEv);
		
		}*/
		
		/**
		* This method changes screen to ScreenNewRecipe.
		*/
		private function goToNewRecipe(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_NEWRECIPE_I);
			dispatchEvent(screenEv);
		
		}
		
		/**
		* This method changes screen to ScreenSearchRecipe.
		*/
		private function goToSearchRecipe(ev:MouseEvent):void {
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_SEARCHRECIPE);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method changes screen to ScreenCalendar.
		*/
		private function goToOptions(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_SETTINGS);
			dispatchEvent(screenEv);
			
		}

		
		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void {
			editBt_sp.removeEventListener(MouseEvent.CLICK,goToNewRecipe);
			searchBt_sp.removeEventListener(MouseEvent.CLICK,goToSearchRecipe);
			optionsBt_sp.removeEventListener(MouseEvent.CLICK, goToOptions);
			closeBt_sp.removeEventListener(MouseEvent.CLICK, closeApp);
		
			super.dispose(ev);
		}
	}

}