package spujol.tfg.sp.screens.app 
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TransformGestureEvent;	
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	import flash.net.SharedObject;
	
	import spujol.tfg.sp.ui.bt.AppHelpIcon;
	import spujol.tfg.sp.ui.bt.AppSearchBt;
	import spujol.tfg.sp.ui.form.InputBox;
	import spujol.tfg.sp.ui.form.InputDropList;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.instances.SearchRecipe;
	import spujol.tfg.sp.instances.ResultBar;
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	public class ScreenSearchRecipe extends ScreenTopBar
	{		
		public var backBt_sp:Sprite;
		public var helpBt_sp:AppHelpIcon;
		public var bgForm_sp:Sprite;
		public var resultsCont_sp:Sprite;
		public var preloader:Preloader;
		public var resultBar_sp:ResultBar;
		public var authorInput_sp:InputBox;
		public var collectionInput_sp:InputDropList;
		public var ingredientInput_sp:InputBox;
		public var portionInput_sp:InputDropList;
		public var searchBt_sp:AppSearchBt;
		public var textError:TextField;
		private var	_state:Boolean;
		private var _collectionsArray:Array = null;
		private var _ingredientsArray:Array = null; 
		private var _authorArray:Array = null; 
		private var _rationArray:Array = null;
		private var	_dbAPI:DBappAPI;
		private var _sharedObjectRecipe:SharedObject
		private var _arraySearch:Array = null;
		private var _arrayResults:Array = null;
		private var _posY:int;
		private var _userID:int;
		private var _totalForSwipe:int = 3;
		
		public function ScreenSearchRecipe(state:Boolean, arrayData:Array, userID:int) 
		{
			_state = state;
			
			_ingredientsArray = arrayData[0];
			_collectionsArray = arrayData[2];
			_authorArray = arrayData[3];
			_rationArray =  new Array("2", "4", "6");
			_userID = userID;
			
			super();
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			screenTitle_tf.text = "Buscar receta";

			if (_state == true){
				helpBt_sp = new AppHelpIcon();
				addChild(helpBt_sp);
				helpBt_sp.addEventListener(MouseEvent.CLICK,showHelp);
			}
			
			getDataSO();
			
			backBt_sp.buttonMode = true;
			backBt_sp.mouseChildren = false;
			
			searchBt_sp = new AppSearchBt();	
			addChild(searchBt_sp);
			
			if (_arrayResults == null){
			authorInput_sp = new InputBox("Nombre del autor", _authorArray);
			collectionInput_sp  = new InputDropList("Colección", _collectionsArray);
			ingredientInput_sp = new InputBox("Ingrediente", _ingredientsArray);
			portionInput_sp  = new InputDropList("Número de raciones", _rationArray, true, "Indica la cantidad deseada");
			
			} else {
			
				if ((_arraySearch[0] == "") || (_arraySearch[0] == "Nombre del autor")) {
						authorInput_sp = new InputBox("Nombre del autor", _authorArray); 
				} else {authorInput_sp = new InputBox(_arraySearch[0], _authorArray); }
				if ((_arraySearch[1] == "") || (_arraySearch[1] == "Colección"))  {
					collectionInput_sp  = new InputDropList("Colección", _collectionsArray);
				} else {collectionInput_sp  = new InputDropList(_arraySearch[1], _collectionsArray); }
				if ((_arraySearch[2] == "") || (_arraySearch[2] == "Ingrediente")) {
					ingredientInput_sp = new InputBox("Ingrediente", _ingredientsArray);
				} else {ingredientInput_sp = new InputBox(_arraySearch[2], _ingredientsArray); }
				if ((_arraySearch[3] == "") || (_arraySearch[3] == "Número de raciones")) {
					portionInput_sp  = new InputDropList("Número de raciones", _rationArray, true, "Indica la cantidad deseada");
				} else {portionInput_sp  = new InputDropList(_arraySearch[3], _rationArray, true, "Indica la cantidad deseada"); }	
				
				printResults();
			}
			
			portionInput_sp.inputBoxText_tf.restrict = "0-9";
			
			addChild(portionInput_sp);
			addChild(ingredientInput_sp);
			addChild(collectionInput_sp);
			addChild(authorInput_sp);
			
			//Listeners
			backBt_sp.addEventListener(MouseEvent.CLICK, goBack);
			searchBt_sp.addEventListener(MouseEvent.CLICK, validateInputs);
			
			// sobre moviments tàctils
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			//Execute init from superclass
			super.init(ev);
	
			resizeHandler();
		}
		
		
		/**
		* This method validates inputs.
		*/
		protected function validateInputs(ev:MouseEvent):void {
			_sharedObjectRecipe.clear();			
			_arraySearch = new Array();
			_arrayResults = new Array();
			
			var author:String = authorInput_sp.inputBoxText_tf.text;
			var collection:String = collectionInput_sp.inputBoxText_tf.text;
			var ingredient:String = ingredientInput_sp.inputBoxText_tf.text.toUpperCase();
			var portion:String = portionInput_sp.inputBoxText_tf.text;
			
			if (authorInput_sp.inputBoxText_tf.text == "Nombre del autor"){author = ""; }
			if (collectionInput_sp.inputBoxText_tf.text == "Colección"){collection = ""; }
			if (ingredientInput_sp.inputBoxText_tf.text == "Ingrediente"){ingredient = ""; }
			if ((portionInput_sp.inputBoxText_tf.text == "Número de raciones") || (portionInput_sp.inputBoxText_tf.text == "Indica la cantidad deseada")){portion = ""; }

			if ((!author) && (!collection) && (!ingredient) && (!portion)) {
				removeResults();				
				writeTextError("Indica, al menos, un parametro de búsqueda.");
				
			} else {
				
				_arraySearch.push(author);
				_arraySearch.push(collection);
				_arraySearch.push(ingredient);
				_arraySearch.push(portion);
				
				setDataSO("search");
				
				searchRecipe(_arraySearch);
			}
		}
		
		
		/**
		* This method search recipes in coincidence with inputs.
		*/
		protected function searchRecipe(array:Array):void {
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, showResults);
			_dbAPI.loadSearchRecipeResults("searchRecipe", array[0], array[1], array[2], array[3]);

			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);
		}
		
		
		/**
		* This method saves results in an array and shows them.
		*/
		protected function showResults(ev:DBAPIEvent):void {
			removeChild(preloader);
			_arrayResults = ev.data;
			setDataSO("results");
			printResults();
		}
		
		
		/**
		* This method puts results in the screen.
		*/
		protected function printResults() {
				removeResults();
			
			var total:int = _arrayResults.length;
			var totalStr:String = total.toString();
			
			if (total > 0){ 
				resultBar_sp = new ResultBar(totalStr);
				addChild(resultBar_sp);

			} else {
				writeTextError("No se han encontrado resultados.");
			}
				
			for (var i:int = 0; i < total; i++){
				
				var rec:SearchRecipe = new SearchRecipe(_arrayResults[i], _userID);
				
				rec.name = "rec" + i;
				resultsCont_sp.addChild(rec);
			}
			
			resizeHandler();
		}
		
		
		
		/**
		* This method remove results from the screen.
		*/
		protected function removeResults(){
			while (resultsCont_sp.numChildren){
				resultsCont_sp.removeChildAt(0);
			}
			if (this.numChildren > 12){ this.removeChild(resultBar_sp);}
			
		}

		
		/**
		* This method writes error message.
		*/
		private function writeTextError(errorText:String){
			textError = new TextField;

			textError.autoSize = "center";
			textError.defaultTextFormat = new TextFormat("Verdana", 36, 0, null, null, null, null, null, "center");
			textError.multiline = true;
			textError.wordWrap = true;
			textError.text = errorText;
			textError.textColor = 0xab2a3e;
			textError.width = stageW;
			textError.y = textError.height;
			
			resultsCont_sp.addChild(textError);
		}
		
		
		/**
		* This method goes screen back.
		*/
		private function goBack(ev:MouseEvent):void {
			_sharedObjectRecipe.clear();

			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.BACK, false, false);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method shows help.
		*/
		protected function showHelp(ev:MouseEvent):void {	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method sets data on Share Object
		*/
		protected function setDataSO(from:String):void{	
			_sharedObjectRecipe = SharedObject.getLocal("searchRecipe");	
			if (from == "search"){_sharedObjectRecipe.data.search = _arraySearch; }
			if (from == "results"){_sharedObjectRecipe.data.results = _arrayResults;}	
			_sharedObjectRecipe.flush();
		}
		
		
		/**
		* This method gets data from Share Object
		*/
		protected function getDataSO(){	
			_sharedObjectRecipe = SharedObject.getLocal("searchRecipe");
			_arraySearch = _sharedObjectRecipe.data.search;
			_arrayResults = _sharedObjectRecipe.data.results;
		}
		
		
		/**
		* This method controls scroll tactil events.
		*/
		private function onSwipe(ev:TransformGestureEvent):void{
			if (ev.offsetY == -1) {
				var arrayCopy:Array = _arrayResults.slice(_totalForSwipe);
				var total:int = arrayCopy.length;
								
				if (total > 0){
					
					removeResults();
					
					for (var i:int = 0; i < arrayCopy.length; i++){	
						var rec:SearchRecipe = new SearchRecipe(arrayCopy[i], _userID);
						rec.name = "rec" + i;
						resultsCont_sp.addChild(rec);
					}		
				}
				
				_totalForSwipe += 3;
				
				resultsCont_sp.x =  stageW/2 - resultsCont_sp.width/2;
				resultsCont_sp.y = bgForm_sp.y + bgForm_sp.height + authorInput_sp.height;
				
				if (resultsCont_sp.numChildren > 0){	

				var posY:int = 0;

					for (var j:int = 0; j < arrayCopy.length; j++){
						resultsCont_sp.getChildByName("rec" + j).y = _posY;
						resultsCont_sp.getChildByName("rec" + j).x = 0;
						_posY = _posY + resultsCont_sp.getChildByName("rec" + j).height;
					}
					
				}	
			
			
			} else if (ev.offsetY == 1) {
				
				_totalForSwipe = 3;
				printResults();
			}
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();		
			var MES:int = authorInput_sp.height * 1.5;
			
			
			if (_state == true) {
				helpBt_sp.x = stageW - GUTTERH;
				helpBt_sp.y = stageH - GUTTERH;
			}
			
			bgForm_sp.x = 0;
			bgForm_sp.y = topBarH;
			bgForm_sp.width = stageW;
			bgForm_sp.height = searchBt_sp.y + MES - topBarH;

			authorInput_sp.x = stageW/2 - authorInput_sp.width/2;
			collectionInput_sp.x = stageW/2 - collectionInput_sp.width/2;
			ingredientInput_sp.x = stageW/2 - ingredientInput_sp.width/2;
			portionInput_sp.x = stageW / 2 - portionInput_sp.width / 2;
			searchBt_sp.x = stageW/2 - searchBt_sp.width/2;
			
			authorInput_sp.y  = bgForm_sp.y + authorInput_sp.height;;
			collectionInput_sp.y = authorInput_sp.y + MES; 
			ingredientInput_sp.y = collectionInput_sp.y + MES; 
			portionInput_sp.y = ingredientInput_sp.y + MES;
			searchBt_sp.y = portionInput_sp.y + MES;
			
			resultsCont_sp.x =  stageW/2 - resultsCont_sp.width/2;
			resultsCont_sp.y = bgForm_sp.y + bgForm_sp.height + authorInput_sp.height;
			
			_posY = 0;
			
			if (resultsCont_sp.numChildren > 0){//(this.numChildren > 12){ 
				resultBar_sp.x = stageW/2 - resultBar_sp.width/2;
				resultBar_sp.y = bgForm_sp.y + bgForm_sp.height;
				
				for (var i:int = 0; i < _arrayResults.length; i++){
					resultsCont_sp.getChildByName("rec" + i).y = _posY;
					resultsCont_sp.getChildByName("rec" + i).x = 0;
					_posY = _posY + resultsCont_sp.getChildByName("rec" + i).height;
				}
			}
		}
	
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			backBt_sp.removeEventListener(MouseEvent.CLICK,goBack);
			searchBt_sp.removeEventListener(MouseEvent.CLICK, validateInputs);
			stage.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
		}
	}
}