package spujol.tfg.sp.screens.app 
{
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.net.SharedObject;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TransformGestureEvent;	
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	import spujol.tfg.sp.instances.ViewRecipeValoration;
	import spujol.tfg.sp.instances.ViewRecipeBar;	
	import spujol.tfg.sp.instances.ui.Ingredient;
	import spujol.tfg.sp.instances.ui.ProcessPoint;
	import spujol.tfg.sp.instances.ui.Recipe;
	import spujol.tfg.sp.ui.bt.AppHelpIcon;
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	import spujol.tfg.sp.ui.bt.AppOriginalBt;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	
	public class ScreenViewRecipe extends ScreenTopBar
	{
		public var backBt_sp:Sprite;
		public var useBt_sp:Sprite;
		public var edit_sp:Sprite;
		public var cont_sp:Sprite;
		public var helpBt_sp:AppHelpIcon;
		public var recipeBarIng:ViewRecipeBar;
		public var recipeBarPro:ViewRecipeBar;
		public var ingredient:Ingredient;
		public var process:ProcessPoint;
		public var valoration:ViewRecipeValoration;
		public var imgCont_sp:Sprite;
		
		private var _sharedObjectRecipe:SharedObject;
		private var _sharedObject:SharedObject;
		private var _sharedObjectMR:SharedObject;
		
		private var	_state:Boolean;
		private var	_recipeData:Object = {
						name: "",
						author: "",
						likes: "",
						value: "",
						pax: "",
						id: "",
						thumb: "",
						img: "",
						original: "",
						originalID: ""
					};
					
		private var	_ingredients:Array = null;
		private var	_procediments:Array = null;
		private var	_reused:Array = null;
		private var _posY:int;
		private var _grandPa: int;
		private var _loveStatus:Boolean = false;
		private var _likeStatus:Boolean = false;
		private var _userID:int;
		private var _original:AppOriginalBt;
		private var _fullRecipe:Object;
		
		
		
		public function ScreenViewRecipe(state:Boolean, fullRecipe:Object, grandPa:int, userId:int)
		{
			_state = state;
			_grandPa = grandPa;
			_userID = userId;
			
			
			_sharedObject = SharedObject.getLocal("viewRecipe");

			if (fullRecipe != null) {
				_fullRecipe = fullRecipe;
				_sharedObject.data.fullRecipe = _fullRecipe;
				_sharedObject.flush();
			} else {
				_fullRecipe = _sharedObject.data.fullRecipe;
			}
				_recipeData = _fullRecipe.recipe;
				_ingredients = _fullRecipe.ingredients;
				_procediments = _fullRecipe.procediments;
				_likeStatus = _fullRecipe.likeStatus;
				_loveStatus = _fullRecipe.loveStatus;
				_reused = _fullRecipe.reused;
			
			super();
		}
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			screenTitle_tf.text = "Receta";
			
			if (_state == true){
				helpBt_sp = new AppHelpIcon();
				addChild(helpBt_sp);
				helpBt_sp.addEventListener(MouseEvent.CLICK,showHelp);
			}
			
			backBt_sp.buttonMode = true;
			backBt_sp.mouseChildren = false;
			backBt_sp.addEventListener(MouseEvent.CLICK, goBack);
			
			if (_grandPa == 9){
				useBt_sp.visible = true;
				useBt_sp.buttonMode = true;
				useBt_sp.mouseChildren = false;
				useBt_sp.addEventListener(MouseEvent.CLICK, useRecipe);
				edit_sp.visible = false;
			} else if (_grandPa == 8) {
				edit_sp.visible = true;
				edit_sp.buttonMode = true;
				edit_sp.mouseChildren = false;
				edit_sp.addEventListener(MouseEvent.CLICK, reeditRecipe);
				useBt_sp.visible = false;
			} else if ((_grandPa == 12) || (_grandPa == 14) || (_grandPa == 15)){
				useBt_sp.visible = false;
				edit_sp.visible = false;
			}
		
			
			if (_recipeData.img != null){
				cont_sp.addChild(imgCont_sp);
				
				var loader:Loader = new Loader();
				var url:String = "http://eimtcms.uoc.edu/~soniapf/php/" + _recipeData.img;
				var urlRequest:URLRequest = new URLRequest(url);
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);		
				loader.load(urlRequest);
			}
						
			recipeBarIng =  new ViewRecipeBar("Ingredientes", _recipeData.pax);
			cont_sp.addChild(recipeBarIng);
			
			var recTotal:int = _reused.length;
			for (var h:int = 0; h < recTotal; h++){
				var rec:Recipe = new Recipe(_reused[h][0], _reused[h][1], _userID, _reused[h][2])
				rec.name = "rec" + h;
				cont_sp.addChild(rec);
			}
			
			var ingTotal:int = _ingredients.length;
			for (var i:int = 0; i < ingTotal; i++){
				var ing:Ingredient = new Ingredient(_ingredients[i][0], _ingredients[i][1], _ingredients[i][2]);
				ing.name = "ing" + i;
				cont_sp.addChild(ing);
			}
			
			recipeBarPro =  new ViewRecipeBar("Elaboración", _recipeData.pax);
			cont_sp.addChild(recipeBarPro);
			
			var proTotal:int = _procediments.length;
			for (var j:int = 0; j < proTotal; j++){
				
				var pro:ProcessPoint= new ProcessPoint(_procediments[j][0], _procediments[j][1]);
				pro.name  = "pro" + j;
				cont_sp.addChild(pro);
			}
			
			
			
			if (_recipeData.original != null){						
				_original = new AppOriginalBt (_recipeData.original, _recipeData.originalID, _userID);
				addChild(_original);
			}
			
			valoration = new ViewRecipeValoration(_loveStatus, _likeStatus, _recipeData.name, _recipeData.id, _userID);
			addChild(valoration);
			
			
			// sobre moviments tàctils
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			cont_sp.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			resizeHandler();
			
		}	
		
		/**
		* This method puts images into displaylist
		*/
		private function completeHandler(ev:Event):void {
			//Remove listeners
			removeEventListener(Event.COMPLETE, completeHandler);
			if (imgCont_sp.numChildren > 0) {imgCont_sp.removeChildAt(0); }
		
			var img = ev.target.content;
			img.width = stageW;
			img.height = stageW/1.333333;
			imgCont_sp.addChild(img);
		}
	
		
		/**
		* This method lets create new recipe with a base recipe.
		*/
		private function reeditRecipe(ev:MouseEvent):void{
			
			_sharedObjectRecipe = SharedObject.getLocal("searchRecipe");
			_sharedObjectRecipe.clear();

			
			var _ingredientsOb:Array = new Array();
			var ingTotal:int = _ingredients.length;
			for (var i:int = 0; i < ingTotal; i++){
				var ing:Object = new Object();
				ing.ingredient = _ingredients[i][0];
				ing.quantity = _ingredients[i][1];
				ing.measure =  _ingredients[i][2];
				
				_ingredientsOb.push(ing);
			}
			
			var _procedimentsOb:Array = new Array();
			var proTotal:int = _procediments.length;
			for (var j:int = 0; j < proTotal; j++){
				var pro:Object = new Object();
				pro.number = _procediments[j][0];
				pro.text = _procediments[j][1];

				_procedimentsOb.push(pro);
			}
			
			
			var _reusedOb:Array = new Array();
			var recTotal:int = _reused.length;
			for (var h:int = 0; h < recTotal; h++){
				var rec:Object = new Object();
				rec.id = _reused[h][0];
				rec.name = _reused[h][1];

				_reusedOb.push(rec);
			}
			
			var recipeReedit:Object= {
					ingredients:_ingredientsOb, 
					procediments:_procedimentsOb,
					reused:_reusedOb,
					original: _recipeData.id
				};
			
				
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_NEWRECIPE_I, recipeReedit);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method shows help.
		*/
		protected function showHelp(ev:MouseEvent):void {	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method goes screen back.
		*/
		protected function useRecipe(ev:MouseEvent):void {
			var recipe:Object= {
					id:_recipeData.id, 
					name:_recipeData.name
				};	
			
			_sharedObjectRecipe = SharedObject.getLocal("searchRecipe");
			_sharedObjectRecipe.clear();
				
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_NEWRECIPE_I, recipe);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method uses recipes depends on Screen.
		*/
		protected function goBack(ev:MouseEvent):void {
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.BACK, false, false);
			dispatchEvent(screenEv);
		}
		
		/**
		* This method controls scroll tactil events.
		*/
		private function onSwipe(ev:TransformGestureEvent):void{
		
			var num:int = cont_sp.numChildren;
			var lastItem:int = cont_sp.getChildAt(num - 1).y + cont_sp.getChildAt(num - 1).height;
			var i:int;
			var newPosY:int;
					
			
			if (ev.offsetY == -1) {
				if (lastItem > stageH-cont_sp.y){ 
					for (i = 0; i < num; i++){
						newPosY = cont_sp.getChildAt(i).y - 360;
						cont_sp.getChildAt(i).y = newPosY;
					}
					lastItem = cont_sp.getChildAt(num - 1).y + cont_sp.getChildAt(num - 1).height;
				}
				
			} else if (ev.offsetY == 1) {
				resizeHandler();
			}
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();			
			
			useBt_sp.x = stageW - useBt_sp.width;
			
			valoration.x = stageW/2 - valoration.width/2;
			valoration.y = topBarH;
			
			if (_recipeData.original != null){
				_original.x = stageW / 2 - _original.width / 2;
				_original.y = valoration.y + valoration.height + 10;
				
				cont_sp.x = stageW / 2 - cont_sp.width / 2;
				cont_sp.y = _original.y + _original.height + 10;
				
			} else {
				cont_sp.x = stageW / 2 - cont_sp.width / 2;
				cont_sp.y = valoration.y + valoration.height;
			}
			

			//Inside the cont_sp
			
			_posY = 0;
			
			if (_recipeData.img != null){
	
				imgCont_sp.y = _posY;
				imgCont_sp.x = (stageW / 2) - (imgCont_sp.width / 2);
				
			} else { 
				imgCont_sp.y = _posY - imgCont_sp.height;
				
			}
			_posY = imgCont_sp.y + imgCont_sp.height;
				
			recipeBarIng.x = 0;
			recipeBarIng.y = _posY;
			
			_posY += recipeBarIng.height;
			
			for (var h:int = 0; h < _reused.length; h++){
				cont_sp.getChildByName("rec" + h).y = _posY;
				cont_sp.getChildByName("rec" + h).x = cont_sp.width/2 - cont_sp.getChildByName("rec" + h).width/2;
				_posY = _posY + cont_sp.getChildByName("rec" + h).height;
			}
			
			_posY += 10;

			for (var i:int = 0; i < _ingredients.length; i++){
				cont_sp.getChildByName("ing" + i).y = _posY;
				cont_sp.getChildByName("ing" + i).x = 0;
				_posY = _posY + cont_sp.getChildByName("ing" + i).height;
			}
						
			_posY += 20;
			
			recipeBarPro.y = _posY;
			recipeBarPro.x = 0;
			
			_posY = _posY  + recipeBarPro.height + 10;
			
			for (var j:int = 0; j < _procediments.length; j++){
				cont_sp.getChildByName("pro" + j).y = _posY;
				cont_sp.getChildByName("pro" + j).x = 0;
				_posY = _posY + cont_sp.getChildByName("pro" + j).height;
			}
			
			
			if (_state == true) {
				helpBt_sp.x = stageW - GUTTERH;
				helpBt_sp.y = stageH - GUTTERH;
			}
			
		}
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			backBt_sp.removeEventListener(MouseEvent.CLICK,goBack);
			cont_sp.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);

		}
	}
	
}