package spujol.tfg.sp.screens.basic 
{
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.StageOrientation;
	
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.StageOrientationEvent;
	
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class Screen extends Sprite
	{
		// Common variables
		protected var stageW:int;
		protected var stageH:int;
		protected var GUTTERH:int;	
		protected var GUTTERW:int;
				
		public function Screen()
		{
			super();
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			// To remove eventlisteners once the instance is removed from the displayList
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// Situate stage on the top left corner
			stage.align = StageAlign.TOP_LEFT;
			// Unable automatic scaling 
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			// Listeners
			stage.addEventListener(Event.RESIZE,resizeHandler);
			
			resizeHandler();		
		}
		
		
		/**
		* This method removes common listeners.
		*/
		protected function dispose(ev:Event):void{
			removeEventListener(Event.REMOVED_FROM_STAGE, dispose);
			stage.removeEventListener(Event.RESIZE,resizeHandler);
		}
		
		
		/**
		* This method adapts the elements in the screen.
		*/
		protected function resizeHandler(ev:Event = null):void {
			// This method is executed at each change of dimensions
			// and will be adapted for every screen
			stageW = stage.stageWidth;
			stageH = stage.stageHeight;
			
			GUTTERH = stageH/8;
			GUTTERW = stageW/8;
		}
	}
}