package spujol.tfg.sp.screens.gear
{
	
	import flash.text.TextField;	
	import flash.display.Sprite;	
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	import flash.events.KeyboardEvent;
	import flash.net.SharedObject;
	import flash.desktop.NativeApplication;
	import spujol.tfg.sp.api.DBAPI;
	import spujol.tfg.sp.api.DBAPIEvent;	
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;

		
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenLogin extends ScreenForm
	{
		public var register_sp:Sprite;
		public var forgetPass_sp:Sprite;
		public var input1:Sprite;
		public var input2:Sprite;
		public var closeBt_sp:Sprite;
		public var userNameLabel_tf:TextField;
		public var userNameInput_tf:TextField;	
		public var passLabel_tf:TextField;
		public var passInput_tf:TextField;
		private var _sharedObject:SharedObject;
		private var _dbAPI:DBAPI;
		private var _loginData:Array = null; 
			
		
		public function ScreenLogin() 
		{
			super();
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {

			stage.focus = userNameInput_tf;
			
			// Hide text from password Input
			passInput_tf.displayAsPassword = true;
			
			// Change cursor on hover
			forgetPass_sp.buttonMode = true;
			register_sp.buttonMode = true;
			closeBt_sp.buttonMode = true;
			
			// Unable click detection on internal instances
			forgetPass_sp.mouseChildren = false;
			register_sp.mouseChildren = false;
			closeBt_sp.mouseChildren = false;

			forgetPass_sp.addEventListener(MouseEvent.CLICK,goToRecoverPass);
			register_sp.addEventListener(MouseEvent.CLICK,goToRegister);
			acceptBt_sp.addEventListener(MouseEvent.CLICK, formValidation);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			closeBt_sp.addEventListener(MouseEvent.CLICK, closeApp);
			//Execute init from superclass
			super.init(ev);
		}
		
		/**
		* This method closes App.
		*/		
		private function closeApp(ev:MouseEvent):void{
				_sharedObject = SharedObject.getLocal("searchRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("newRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("viewRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("myRecipes");
				_sharedObject.clear();
				
				NativeApplication.nativeApplication.exit();
		}
		
		
		private function keyDownHandler(ev:KeyboardEvent):void {
			if (ev.keyCode == Keyboard.ENTER) {
				var mouseEvent:MouseEvent = new MouseEvent(MouseEvent.CLICK);
				acceptBt_sp.dispatchEvent(mouseEvent);
			}
		}
		
		/**
		* This method changes screen to ScreenRegister.
		*/
		private function goToRegister(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_REGISTER);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method will generate and send a new password.
		*/
		private function goToRecoverPass(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_RECOVERPASS);
			dispatchEvent(screenEv);	
		}
		
		
		/**
		* This method validates form inputs.
		*/
		private function formValidation(ev:MouseEvent):void {
			
			if (userNameInput_tf.text == ""){
				stage.focus = userNameInput_tf;
				error_tf.text= "Por favor, introduce tu nombre de usuario.";
				
			} else if (passInput_tf.text == ""){ 
				stage.focus = passInput_tf;
				error_tf.text= "Por favor, introduce tu contraseña.";
				
			} else { 
				error_tf.text='';
				// Connect with database				
				_dbAPI = new DBAPI();
				_dbAPI.addEventListener(DBAPIEvent.COMPLETE,userLogin);
				_dbAPI.loadUserData("login", -1,  userNameInput_tf.text, "", passInput_tf.text, "")
				
				
			}
		}


		
		/**
		* This method finds coincidences with database.
		*/
		private function userLogin(ev:DBAPIEvent){

				_loginData =	ev.data;
			
				var nameCoincidence:int = _loginData[3];
				var totalCoincidence:int = _loginData[5];
	
			if (nameCoincidence == 0) {
				error_tf.text= "Lo sentimos, no hay ningun usuario registrado con el nombre '"+ _loginData[1]+"'.";
				stage.focus = userNameInput_tf;
				userNameInput_tf.text = "";
				
			} else if (totalCoincidence == 0) {
				error_tf.text= "Lo sentimos, la contraseña no es correcta.";
				stage.focus = passInput_tf;
				passInput_tf.text = "";
				
			} else {
				error_tf.text= "";
				saveLocalUserId();
			}	
		}
		
		
		/**
		* This method saves user name and id in local.
		*/		
		private function saveLocalUserId(){
			
			try 
			{ 
				var sharedObject:SharedObject = SharedObject.getLocal("userData");
				sharedObject.data.id = _loginData[0];
				sharedObject.data.name = _loginData[1];
				sharedObject.data.email = _loginData[2];
				sharedObject.data.help = true;
				sharedObject.flush();
			} 
			catch (error:Error) 
			{ 
				trace("No ha sido posible crear el SharedObject"); 
			}
			
			goToApp();
		}
		
		/**
		* This method goes to App.
		*/
		private function goToApp(){
			// ********* QUAN L'APP ESTIGUI FINALITZADA, REDIGIREM A LA PÀGINA MENÚ.
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_RECIPEBOOK);
			dispatchEvent(screenEv);
		}		
		
		
		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			// We remove all eventlisteners added when we added the instance to the displayList
			forgetPass_sp.removeEventListener(MouseEvent.CLICK,goToRecoverPass);
			register_sp.removeEventListener(MouseEvent.CLICK,goToRegister);
			acceptBt_sp.removeEventListener(MouseEvent.CLICK,formValidation);
			stage.removeEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			closeBt_sp.removeEventListener(MouseEvent.CLICK, closeApp);
			super.dispose(ev);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			
			var inputWidth = stageW - (GUTTERW*2);
	
			userNameLabel_tf.x = GUTTERW;
			userNameLabel_tf.y = GUTTERH*2;
			passLabel_tf.x = GUTTERW;
			passLabel_tf.y = userNameLabel_tf.y + GUTTERH;
			
			input1.width = inputWidth;
			input1.x = GUTTERW;
			input1.y = userNameLabel_tf.y + userNameLabel_tf.height;
			input2.width = inputWidth;
			input2.x = GUTTERW;
			input2.y = passLabel_tf.y + passLabel_tf.height;			
			
			userNameInput_tf.x = GUTTERW + 20;
			userNameInput_tf.width = inputWidth -40;
			userNameInput_tf.y = input1.y + 15;
			passInput_tf.x = GUTTERW + 20;
			passInput_tf.width = inputWidth -40;
			passInput_tf.y = input2.y + 15;
		
			
			register_sp.x = stageW - GUTTERW - register_sp.width;	
			register_sp.y = GUTTERH - register_sp.height;
			
			forgetPass_sp.x = (stageW/2) - (forgetPass_sp.width/2);
			forgetPass_sp.y = passLabel_tf.y + GUTTERH;
		}	
	}
}