package spujol.tfg.sp.screens.gear
{
	
	import flash.text.TextField;	
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.api.DBsetAPI;
	import spujol.tfg.sp.api.DBappAPI;
	import flash.net.SharedObject;
	import flash.desktop.NativeApplication;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.screens.basic.Screen;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;

	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	 
	public class ScreenPopUp extends Screen
	{
		public var cont_sp:Sprite;
		public var text_tf: TextField;
		protected var preloader:Preloader;
		protected var _sharedObjectUser:SharedObject;
		protected var _sharedObjectRecipe:SharedObject;
		protected var _sharedObject:SharedObject;
		protected var _shOb:SharedObject;
		protected var _dbAPIset:DBsetAPI;
		protected var _dbAPI = DBappAPI;
		protected var _from:String;
		protected var _text:String;
		protected var _nextScreen:int;
		protected var _recipeID:String;
		protected var _userID:String;
		
		public function ScreenPopUp(from:String, popUp:Object) 
		{
			
			_from = from;
			_text = popUp.text;
			_nextScreen = popUp.nextScreen;
			_recipeID = popUp.recipeID;
			_userID = popUp.userID;
			
			super();
		}
		
		protected override function init(ev:Event):void {
			
			trace ("popup: " + _recipeID +", " +_userID);
			
			if ((_from == "newRecipeI") || (_from == "newRecipeP") || (_from == "newRecipeD")){_from = "newRecipe"; }
			
			_sharedObjectUser = SharedObject.getLocal("userData");
			_sharedObjectRecipe = SharedObject.getLocal("newRecipe");
			
			text_tf.wordWrap = true;
			text_tf.text = _text;
			
			//Execute init from superclass
			super.init(ev);
		}
		
		
		/**
		* This method goes to App.
		*/
		protected function goTo(ev:MouseEvent){
			
			if (_from == "myRecipes"){
				
				_dbAPIset = new DBsetAPI();
				_dbAPIset.addEventListener(DBAPIEvent.COMPLETE, removedRecipe);
				_dbAPIset.loadDeleteRecipe("deleteMyRecipe", _recipeID);

				preloader = new Preloader();
				preloader.x = stage.stageWidth/2;
				preloader.y = stage.stageHeight/2;;
				addChild(preloader);
			
			} else if (_from == "recipeBook") {
				
				_sharedObject = SharedObject.getLocal("searchRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("newRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("viewRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("myRecipes");
				_sharedObject.clear();
				
				NativeApplication.nativeApplication.exit();
			
			} else {
			
				if (_from == "settings"){_sharedObjectUser.clear();}
				if (_from == "newRecipe"){_sharedObjectRecipe.clear();}
				
				var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, _nextScreen);
				dispatchEvent(screenEv);
			}
		}
		
		
		protected function removedRecipe(ev:DBAPIEvent = null):void {
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipes);
			_dbAPI.loadRecipes("recipeBook", "MIS RECETAS", _userID);
		}
		
		/**
		* This method goes to collections screen.
		*/
		private function viewRecipes(ev:DBAPIEvent):void {
			removeChild(preloader); 
			
			var object:Object = new Object();
			
			object.name = "MIS RECETAS";
			object.array = ev.data;
	
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_MYRECIPES, object);
			dispatchEvent(screenEv);
		}
		
		/**
		* This method stays in app.
		*/
		protected function stayIn(ev:MouseEvent){
			
			if (_from == "myRecipes"){
			
			removedRecipe();
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);
			
			} else {
				
				var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.BACK, false, false);
				dispatchEvent(screenEv)
			}
		}
		
		/**
		* This method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			
			cont_sp.width = stageW;
			cont_sp.height = stageH;
			
			text_tf.width = stageW - (GUTTERW*2);
			text_tf.x =  (stageW/2) - (text_tf.width/2); 
			text_tf.y = GUTTERH*3;
		}
	}
}