package spujol.tfg.sp.screens.gear 
{
	import flash.text.TextField;
	
	import flash.display.Sprite;
	
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.ui.Keyboard;
	import flash.net.SharedObject;
	import spujol.tfg.sp.ui.bt.AppAcceptBt;
	import spujol.tfg.sp.api.DBAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;

		
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenRecoverPass extends ScreenForm
	{
		public var topBarLine_sp:Sprite;
		public var input1:Sprite;
		public var input2:Sprite;
		public var backBt_sp:Sprite;
		
		public var label1_tf:TextField;
		public var input1_tf:TextField;	
		public var label2_tf:TextField;
		public var input2_tf:TextField;
		public var screenTitle_tf:TextField;

		private var _dbAPI:DBAPI;
		private var _phpData:Array = null; 
		
		public function ScreenRecoverPass() 
		{	
			super();
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {
	
			input1_tf.text= "";
			input2_tf.text= "";
			
			stage.focus = input1_tf;
			
			// Change cursor on hover
			backBt_sp.buttonMode = true;

			// Unable click detection on internal instances
			backBt_sp.mouseChildren = false;

			//Listeners
			backBt_sp.addEventListener(MouseEvent.CLICK,goToLogin);
			acceptBt_sp.addEventListener(MouseEvent.CLICK, formValidation);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			
			//Execute init from superclass
			super.init(ev);
		}
		
		
		/**
		* This method changes screen back to login.
		*/
		private function goToLogin(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_LOGIN);
			dispatchEvent(screenEv);
		}
		
		
		private function keyDownHandler(ev:KeyboardEvent):void {
			if (ev.keyCode == Keyboard.ENTER) {
				var mouseEvent:MouseEvent = new MouseEvent(MouseEvent.CLICK);
				acceptBt_sp.dispatchEvent(mouseEvent);
			}
		}
		
		
		/**
		* This method validates form inputs.
		*/
		private function formValidation(ev:MouseEvent):void {
			
			var emailRegularExpression:RegExp =/^[a-z][\w.-]+@\w[\w.-]+\.[\w.-]*[a-z][a-z]$/i;

			if (input1_tf.text == ""){
				stage.focus = input1_tf;
				error_tf.text= "Por favor, introduce tu nombre de usuario.";
				
			} else if (input2_tf.text == ""){ 
				stage.focus = input2_tf;
				error_tf.text= "Por favor, introduce tu email.";
				
			} else if (emailRegularExpression.test(input2_tf.text) == false){
				stage.focus = input2_tf;
				error_tf.text= "Por favor, introduce un email válido.";
				
			} else { 
				error_tf.text='';
				// Connect with database				
				_dbAPI = new DBAPI();
				_dbAPI.addEventListener(DBAPIEvent.COMPLETE,checkData);
				_dbAPI.loadUserData("recoverPass", -1, input1_tf.text, input2_tf.text, "", "")	
			}
		}


		/**
		* This method checks data with database.
		*/
		private function checkData(ev:DBAPIEvent){
				
			_phpData =	ev.data;	
				
				var nameCoincidence:int = _phpData[3];
				var totalCoincidence:int = _phpData[5];
	
			if (nameCoincidence == 0) {
				error_tf.text= "Lo sentimos, no hay ningun usuario registrado con el nombre '"+ _phpData[1]+"'.";
				stage.focus = input1_tf;
				input1_tf.text = "";
				
			} else if (totalCoincidence == 0) {
				error_tf.text= "Lo sentimos, el email no coincide con el usuario registrado.";
				stage.focus = input2_tf;
				input2_tf.text = "";
				
			} else {
				error_tf.text= "";			
				_dbAPI = new DBAPI();
				_dbAPI.addEventListener(DBAPIEvent.COMPLETE,showPopUp);
				_dbAPI.loadUserData("recoverPassChange", -1, _phpData[1], _phpData[2], "", "");
				
			}
		}
		
		
		/**
		* This method shows a popUp message.
		*/
		private function showPopUp(ev:DBAPIEvent){
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPONE);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			// We remove all eventlisteners added when we added the instance to the displayList
			acceptBt_sp.removeEventListener(MouseEvent.CLICK,formValidation);
			backBt_sp.removeEventListener(MouseEvent.CLICK, goToLogin);
			stage.removeEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			super.dispose(ev);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();

			var inputWidth = stageW - (GUTTERW*2);
			
			label1_tf.x = GUTTERW;
			label1_tf.y = GUTTERH*2;
			label2_tf.x = GUTTERW;
			label2_tf.y = label1_tf.y + GUTTERH;
			
			input1.width = inputWidth;
			input1.x = GUTTERW;
			input1.y = label1_tf.y + label1_tf.height;
			input2.width = inputWidth;
			input2.x = GUTTERW;
			input2.y = label2_tf.y + label2_tf.height;			
			
			input1_tf.x = GUTTERW + 20;
			input1_tf.width = inputWidth -40;
			input1_tf.y = input1.y + 15;
			input2_tf.x = GUTTERW + 20;
			input2_tf.width = inputWidth -40;
			input2_tf.y = input2.y + 15;
			
			topBarLine_sp.width = stageW;
			
			screenTitle_tf.x = (stageW/2) - (screenTitle_tf.width/2);
		}	
	}
}