package spujol.tfg.sp.screens.gear
{
	
	import flash.text.TextField;	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.net.SharedObject;
	import flash.ui.Keyboard;
	import flash.desktop.NativeApplication;
	import spujol.tfg.sp.ui.bt.AppPointBt;
	import spujol.tfg.sp.api.DBAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.ui.bt.AppLargeBt;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenRegister extends ScreenForm
	{
		public var pointBt_sp:AppPointBt;
				
		public var input1:Sprite;
		public var input2:Sprite;
		public var input3:Sprite;
		public var input4:Sprite;
		public var login_sp:Sprite;
		public var termsLink_sp:Sprite;
		public var closeBt_sp:Sprite;
		public var userNameLabel_tf:TextField;
		public var userNameInput_tf:TextField;	
		public var emailLabel_tf:TextField;
		public var emailInput_tf:TextField;
		public var passLabel_tf:TextField;
		public var passInput_tf:TextField;
		public var passConfLabel_tf:TextField;
		public var passConfInput_tf:TextField;
		public var termsLabel_tf:TextField;
		private var _sharedObject:SharedObject;	
		private var _dbAPI:DBAPI;
		private var _registerData:Array = null; 	

		
		public function ScreenRegister() 
		{
			super();
		}
	
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			
			pointBt_sp = new AppPointBt(false);
			addChild(pointBt_sp);
			
			stage.focus = userNameInput_tf;

			// Hide text from password Inputs
			passInput_tf.displayAsPassword = true;
			passConfInput_tf.displayAsPassword = true;
			
			
			// Change cursor on hover
			login_sp.buttonMode = true;
			termsLink_sp.buttonMode = true;
			closeBt_sp.buttonMode = true;
			// Unable click detection on internal instances
			login_sp.mouseChildren = false;
			termsLink_sp.mouseChildren = false;
			closeBt_sp.mouseChildren = false;

			//Listeners
			login_sp.addEventListener(MouseEvent.CLICK,goToLogin);
			termsLink_sp.addEventListener(MouseEvent.CLICK,viewTerms);
			acceptBt_sp.addEventListener(MouseEvent.CLICK, formValidation);
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			closeBt_sp.addEventListener(MouseEvent.CLICK, closeApp);

			//Execute init from superclass
			super.init(ev)
		}
		
		
		/**
		* This method closes App.
		*/		
		private function closeApp(ev:MouseEvent):void{
				_sharedObject = SharedObject.getLocal("searchRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("newRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("viewRecipe");
				_sharedObject.clear();
			
				_sharedObject = SharedObject.getLocal("myRecipes");
				_sharedObject.clear();
				
				NativeApplication.nativeApplication.exit();
		}
		
		private function keyDownHandler(ev:KeyboardEvent):void {
			if (ev.keyCode == Keyboard.ENTER) {
				var mouseEvent:MouseEvent = new MouseEvent(MouseEvent.CLICK);
				acceptBt_sp.dispatchEvent(mouseEvent);
			}
		}
		
		
		/**
		* This method changes screen to ScreenLogin.
		*/
		private function goToLogin(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_LOGIN);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method changes screen to ScreenLegalNote.
		*/
		private function viewTerms(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method validates form inputs.
		*/
		private function formValidation(ev:MouseEvent):void {
			
			var emailRegularExpression:RegExp =/^[a-z][\w.-]+@\w[\w.-]+\.[\w.-]*[a-z][a-z]$/i;

			if (userNameInput_tf.text == ""){
				stage.focus = userNameInput_tf;
				error_tf.text= "Por favor, introduce un nombre de usuario.";
				
			} else if (emailInput_tf.text == ""){ 
				stage.focus = emailInput_tf;
				error_tf.text= "Por favor, introduce un email.";
				
			} else if (emailRegularExpression.test(emailInput_tf.text) == false){
				stage.focus = emailInput_tf;
				error_tf.text= "Por favor, introduce un email válido.";
				
			} else if (passInput_tf.text == ""){ 
				stage.focus = passInput_tf;
				error_tf.text= "Por favor, introduce una contraseña.";
				
			} else if (passConfInput_tf.text == ""){ 
				stage.focus = passConfInput_tf;
				error_tf.text= "Por favor, confirma la contraseña.";
				
			} else if (passInput_tf.text != passConfInput_tf.text){
				passInput_tf.text = "";
				passConfInput_tf.text = "";
				stage.focus = passInput_tf;
				error_tf.text= "Lo sentimos, las contraseñas no coinciden. Por favor, vuelve a indicarlas.";
				
			} else if (pointBt_sp.getState()==false){ 
				error_tf.text= "Por favor, tienes que aceptar los términos de uso.";
				
			} else { 
				error_tf.text='';
				// Connect with database				
				_dbAPI = new DBAPI();
				_dbAPI.addEventListener(DBAPIEvent.COMPLETE,findCoincidences);
				_dbAPI.loadUserData("register", -1, userNameInput_tf.text, emailInput_tf.text, passInput_tf.text, "");
				
			}
		}
		
		
		/**
		* This method finds coincidences with database.
		*/
		private function findCoincidences(ev:DBAPIEvent){

				_registerData =	ev.data;
			
				var nameCoincidence:int = _registerData[3];
				var emailCoincidence:int = _registerData[4];
	
			if (nameCoincidence != 0) {
				error_tf.text= "Lo sentimos, el nombre de usuario '"+ _registerData[1]+"' ya està en uso. Por favor, indica otro.";
				stage.focus = userNameInput_tf;
				userNameInput_tf.text = "";
				
			} else if (emailCoincidence != 0) {
				error_tf.text= "Lo sentimos, el email '"+ _registerData[2]+"'  ya està registrado. Por favor, indica otro.";
				stage.focus = emailInput_tf;
				emailInput_tf.text = "";
				
			} else {
				error_tf.text= "";
				
				_dbAPI = new DBAPI();
				_dbAPI.addEventListener(DBAPIEvent.COMPLETE,saveLocalUserId);	
				_dbAPI.loadUserData("getUserId", -1,  _registerData[1], "", "", "")
			}	
		}
		
		
		/**
		* This method saves user data in local.
		*/		
		private function saveLocalUserId(ev:DBAPIEvent){
			_registerData =	ev.data;
			
			try 
			{ 
				var sharedObject:SharedObject = SharedObject.getLocal("userData");
				sharedObject.data.id = _registerData[0];
				sharedObject.data.name = _registerData[1];
				sharedObject.data.email = _registerData[2];
				sharedObject.data.help = true;
				sharedObject.flush();
			} 
			catch (error:Error) 
			{ 
				trace("Unable to create SharedObject."); 
			}
			showPopUp();
		}

		
		/**
		* This method shows a popUp message.
		*/
		private function showPopUp(){
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPONE);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void{
			login_sp.removeEventListener(MouseEvent.CLICK,goToLogin);
			termsLink_sp.removeEventListener(MouseEvent.CLICK,viewTerms);
			acceptBt_sp.removeEventListener(MouseEvent.CLICK, formValidation);
			stage.removeEventListener(KeyboardEvent.KEY_DOWN,keyDownHandler);
			closeBt_sp.removeEventListener(MouseEvent.CLICK, closeApp);
			super.dispose(ev);
		}
		
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
					
			var inputWidth = stageW - (GUTTERW*2);
	
			userNameLabel_tf.x = GUTTERW;
			userNameLabel_tf.y = GUTTERH + (GUTTERH/4);
			emailLabel_tf.x = GUTTERW;
			emailLabel_tf.y = userNameLabel_tf.y + GUTTERH;
			passLabel_tf.x = GUTTERW;
			passLabel_tf.y = emailLabel_tf.y + GUTTERH;
			passConfLabel_tf.x = GUTTERW;
			passConfLabel_tf.y = passLabel_tf.y + GUTTERH;
			
			input1.width = inputWidth;
			input1.x = GUTTERW;
			input1.y = userNameLabel_tf.y + userNameLabel_tf.height;
			input2.width = inputWidth;
			input2.x = GUTTERW;
			input2.y = emailLabel_tf.y + emailLabel_tf.height;
			input3.width = inputWidth;
			input3.x = GUTTERW;
			input3.y = passLabel_tf.y + passLabel_tf.height;
			input4.width = inputWidth;
			input4.x = GUTTERW;
			input4.y = passConfLabel_tf.y + passConfLabel_tf.height;
			
			
			userNameInput_tf.x = GUTTERW + 20;
			userNameInput_tf.width = inputWidth -40;
			userNameInput_tf.y = input1.y + 15;
			emailInput_tf.x = GUTTERW + 20;
			emailInput_tf.width = inputWidth -40;
			emailInput_tf.y = input2.y + 15;
			passInput_tf.x = GUTTERW + 20;
			passInput_tf.width = inputWidth -40;
			passInput_tf.y = input3.y + 15;
			passConfInput_tf.x = GUTTERW + 20;
			passConfInput_tf.width = inputWidth -40;
			passConfInput_tf.y = input4.y + 15;
			
			login_sp.x = stageW - GUTTERW - login_sp.width;	
			login_sp.y =  GUTTERH - login_sp.height;
			
			pointBt_sp.x = GUTTERW;
			pointBt_sp.y = passConfLabel_tf.y + GUTTERH;
			
			termsLabel_tf.x = GUTTERW + pointBt_sp.width;
			termsLabel_tf.y = passConfLabel_tf.y + GUTTERH;
			
			termsLink_sp.x = termsLabel_tf.x + termsLabel_tf.width;
			termsLink_sp.y = passConfLabel_tf.y + GUTTERH;
			
		}
	}
}