package spujol.tfg.sp.screens.gear 
{
	import flash.text.TextField;
	
	import flash.display.Sprite;
	
	import flash.net.SharedObject;
	
	import flash.events.Event;
	import flash.events.MouseEvent;

	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	import spujol.tfg.sp.ui.btactive.AppHelpBt;
	import spujol.tfg.sp.ui.bt.AppLargeBt;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class ScreenSettings extends ScreenTopBar
	{
		
		public var backBt_sp:Sprite;
		public var helpBt_sp:AppHelpBt;
		public var changePassBt_sp:AppLargeBt;
		public var viewTerms_sp:AppLargeBt;
		
		public var logOut_sp:AppLargeBt;
		
		
		public var name_tf: TextField;
		public var userName_tf: TextField;
		public var userEmail_tf: TextField;
		
		private var sharedObject:SharedObject;
		private var	_state;
		private var	_name;
		private var	_email;
		
		public function ScreenSettings(state:Boolean, name:String, email:String)
		{
			_state = state;
			_name = name;
			_email = email;
			
			super();
		}
		
	
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	
			
			sharedObject = SharedObject.getLocal("userData");
			
			helpBt_sp  = new AppHelpBt(_state);
			changePassBt_sp = new AppLargeBt("Modificar contraseña");
			viewTerms_sp = new AppLargeBt("Ver aviso legal");
			logOut_sp = new AppLargeBt("Cerrar sesión"); 
			
			addChild(helpBt_sp);
			addChild(changePassBt_sp);
			addChild(viewTerms_sp);
			addChild(logOut_sp);
			
			userName_tf.text = _name;
			userEmail_tf.text = _email;
			
			// Change cursor on hover
			backBt_sp.buttonMode = true;
			// Unable click detection on internal instances
			backBt_sp.mouseChildren = false;

			//Listeners
			backBt_sp.addEventListener(MouseEvent.CLICK,goBack);
			helpBt_sp.addEventListener(MouseEvent.CLICK,changeHelpStatus);
			changePassBt_sp.addEventListener(MouseEvent.CLICK,goToRecoverPass);
			logOut_sp.addEventListener(MouseEvent.CLICK,logOut); 
			viewTerms_sp.addEventListener(MouseEvent.CLICK,viewTerms); 
			
			//Execute init from superclass
			super.init(ev);
		}
		
		
		/**
		* This method goes screen back.
		*/
		private function goBack(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.BACK, false, false);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method changes help status on shareObject.
		*/
		private function changeHelpStatus(ev:MouseEvent):void {
			if (_state == true){sharedObject.data.help = false;}
			else if (_state == false){sharedObject.data.help = true;}
			
		}
		

		/**
		* This method goes to screen change Pass.
		*/
		private function goToRecoverPass(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_CHANGEPASS);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This method changes screen to ScreenLegalNote.
		*/
		private function viewTerms(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_TEXT);
			dispatchEvent(screenEv);
		}	
		
		
		/**
		* This method confirms logout.
		*/
		private function logOut (ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, false, false, ScreenTypes.SCREEN_POPUPTWO);
			dispatchEvent(screenEv);
		}
		

		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void {
			backBt_sp.removeEventListener(MouseEvent.CLICK,goBack);
			helpBt_sp.removeEventListener(MouseEvent.CLICK,changeHelpStatus);
			changePassBt_sp.removeEventListener(MouseEvent.CLICK,goToRecoverPass);
			viewTerms_sp.removeEventListener(MouseEvent.CLICK,viewTerms); 
			logOut_sp.removeEventListener(MouseEvent.CLICK,logOut);
			super.dispose(ev);
		}
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			
			name_tf.y = topBarH *2;
			name_tf.x = GUTTERW;
			
			userName_tf.y = name_tf.y + topBarH/2;
			userName_tf.x = GUTTERW + (GUTTERW/2);
			
			userEmail_tf.y = userName_tf.y + topBarH/2;
			userEmail_tf.x = GUTTERW + (GUTTERW/2);
			
			helpBt_sp.x =  (stageW/2) - (helpBt_sp.width/2);
			helpBt_sp.y = userEmail_tf.y +  GUTTERH;
			
			viewTerms_sp.x =  (stageW/2) - (helpBt_sp.width/2);
			viewTerms_sp.y = helpBt_sp.y +  GUTTERH;
			
			changePassBt_sp.x =  (stageW/2) - (changePassBt_sp.width/2);
			changePassBt_sp.y = viewTerms_sp.y +  GUTTERH;
			
			logOut_sp.x =  (stageW/2) - (changePassBt_sp.width/2);
			logOut_sp.y = changePassBt_sp.y +  GUTTERH;
		}
	}

}