 package spujol.tfg.sp.screens.gear
{
	import flash.text.TextField;
	import flash.display.Sprite;
	import spujol.tfg.sp.preloader.Preloader;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.IOErrorEvent;
	import flash.events.TransformGestureEvent;
	
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	
	import flash.ui.MultitouchInputMode;
	import flash.ui.Multitouch;
	
	import spujol.tfg.sp.screens.basic.ScreenTopBar;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;

	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */ 
	 
	public class ScreenText extends ScreenTopBar
	{  
		// Instances
		public var closeBt_sp:Sprite;
		public var text_tf:TextField;
		public var textNote:String;
		private var preloader:Preloader;
		private var _urlRequest:URLRequest;
		private var _urlLoader:URLLoader;
		private var _url:String;
		private var _from:String;
		
		
		public function ScreenText(from:String) 
		{
			_from = from;
			super();
		}
		
		
		/**
		* This method initializes the object.
		*/
		protected override function init(ev:Event):void {	

			switch (_from) {
				
				case "register":
					screenTitle_tf.text= "Aviso legal";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/legalNote.txt";
					
				break;
				
				case "settings":
					screenTitle_tf.text= "Aviso legal";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/legalNote.txt";
					
				break;
				
				case "recipeBook":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpRecipeBook.txt";
					
				break;
				
				case "newRecipeI":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpNewRecipeI.txt";
					
				break;
				
				case "newRecipeP":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpNewRecipeP.txt";
					
				break;
				
				case "newRecipeD":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpNewRecipeD.txt";
					
				break;
				
				case "searchRecipe":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpSearchRecipe.txt";
					
				break;
				
				case "viewRecipe":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpViewRecipe.txt";
					
				break;
				
				case "collection":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpCollection.txt";
					
				break;
				
				case "myRecipes":
					screenTitle_tf.text= "Ayuda";
					_url = "http://eimtcms.uoc.edu/~soniapf/files/helpMyRecipes.txt";
					
				break;
				
			}
		
			loadText();
			
			// Change cursor on hover
			closeBt_sp.buttonMode = true;
			// Unable click detection on internal instances
			closeBt_sp.mouseChildren = false;
			
			// Listeners
			text_tf.addEventListener(MouseEvent.MOUSE_DOWN, mouseDownScroll); 
			closeBt_sp.addEventListener(MouseEvent.MOUSE_DOWN,goBack);
			
			// sobre moviments tàctils
			Multitouch.inputMode = MultitouchInputMode.GESTURE;
			text_tf.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			super.init(ev);
		}
		
			
		/**
		* This method loads external data.
		*/
		private function loadText():void {

			_urlLoader = new URLLoader();
			_urlRequest = new URLRequest(_url);
			
			_urlLoader.addEventListener(Event.COMPLETE, urlLoadCompleteHandler);
			_urlLoader.addEventListener(IOErrorEvent.IO_ERROR, onError);
			
			_urlLoader.load(_urlRequest);
			trace("Loading data...");	
			
			preloader = new Preloader();
			preloader.x = stage.stageWidth/2;
			preloader.y = stage.stageHeight/2;;
			addChild(preloader);
		}
		
		
		/**
		* This method shows an error if it happens.
		*/
		function onError(ev:IOErrorEvent):void {
			trace("ioErrorHandler: " + ev);
		}
		

		/**
		* This method puts load data into textfield.
		*/
		private function urlLoadCompleteHandler (event:Event):void{
			trace("Data loaded");
			removeChild(preloader);
			removeEventListener(Event.COMPLETE, urlLoadCompleteHandler);
			text_tf.text= event.target.data;
		}
		
		
		/**
		* This method controls scroll events.
		*/
		private function mouseDownScroll(event:MouseEvent):void { 
            text_tf.scrollV++; 
        } 
		
		
		/**
		* This method controls scroll tactil events.
		*/
		// ********* Quan estigui l'avís legal, es pot estructurar que avanci punt per punt (+ [línies de cada punt])
		private function onSwipe(ev:TransformGestureEvent):void{
			if (ev.offsetY == -1) {
				text_tf.scrollV = text_tf.scrollV + 10; 
			} else if (ev.offsetY == 1) {
				text_tf.scrollV = text_tf.scrollV - 10;
			}
		}
		
		
		/**
		* This method goes screen back.
		*/
		protected function goBack(ev:MouseEvent):void {
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.BACK, false, false);
			dispatchEvent(screenEv);
		}
		
		
		/**
		* This override method removes listeners.
		*/
		protected override function dispose(ev:Event):void {
			text_tf.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDownScroll); 
			text_tf.removeEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			closeBt_sp.removeEventListener(MouseEvent.MOUSE_DOWN,goBack);
			super.dispose(ev);
		}
		
		/**
		* This override method adapts the elements in the screen.
		*/
		protected override function resizeHandler(ev:Event = null):void {
			super.resizeHandler();
			var med:int = 200;
			text_tf.y = topBarH + med / 2;
			text_tf.x = med / 2;
			text_tf.width = stageW - med;
		}
		
	}

}