package spujol.tfg.sp.ui.bt 
{
	
	import flash.text.TextField;
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;

	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class AppCollectionBt extends AppButton
	{
		public var collectionName_tf:TextField;
		public var containerCollectionItem_sp:Sprite;
		private var _dbAPI:DBappAPI;
		private var _collection:Object;
		private var _preloader:Preloader;
		private var _userID:int;
		private var _collectionItem:Object={
			name : "",
			title : "",
			icon : ""
			};
		
		public function AppCollectionBt(collectionItem:Object, userID:int) 
		{
			// Recover parameters
			_collectionItem = collectionItem;
			this.name = _collectionItem.name;
			_collection = new Object;
			_userID = userID;
				
			super();
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		
		/**
		* This method initializes the object.
		*/		
		private function init(ev:Event):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// Update item name
			collectionName_tf.text = _collectionItem.title;
			
			var logoURL:String = "http://eimtcms.uoc.edu/~soniapf/images/"+_collectionItem.icon+".png";
			
			loadCollectionLogo(logoURL);	
			
			this.addEventListener(MouseEvent.CLICK, onClick);
		}
	
		
		/**
		* This method gets collection' recipes from database
		*/
		private function onClick(ev:MouseEvent):void{
									
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipes);
			_dbAPI.loadRecipes("recipeBook", _collectionItem.title, _userID);
			
			_preloader = new Preloader();
			_preloader.x = stage.stageWidth/2;
			_preloader.y = stage.stageHeight/2;;
			addChild(_preloader);
			
		}
		
		
		/**
		* This method goes to collections screen.
		*/
		private function viewRecipes(ev:DBAPIEvent):void {
			removeChild(_preloader);
			_collection.name = _collectionItem.title;
			_collection.array = ev.data;
			var screenEv:ScreenEvent;
			
			if (_collectionItem.title == "MIS RECETAS") {
			screenEv = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_MYRECIPES, _collection);
			dispatchEvent(screenEv);	 
			} else {
			screenEv = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_COLLECTION, _collection);
			dispatchEvent(screenEv);
			}
		}
		
		
		/**
		* This method loads icons.
		*/		
		private function loadCollectionLogo(urlImage:String):void {
	
			var loader:Loader = new Loader();
			var urlRequest:URLRequest = new URLRequest(urlImage);

			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);		
			loader.load(urlRequest);
		}
		
	
		/**
		* This method puts images into displaylist
		*/
		private function completeHandler(ev:Event):void {
			//Remove listeners
			removeEventListener(Event.COMPLETE, completeHandler);
			if (containerCollectionItem_sp.numChildren > 0) {containerCollectionItem_sp.removeChildAt(0);}
			containerCollectionItem_sp.addChild(ev.target.content);
		}
	}
}