package spujol.tfg.sp.ui.bt 
{
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.events.Event;
	import spujol.tfg.sp.api.DBAPI;
	import spujol.tfg.sp.api.DBappAPI;
	import spujol.tfg.sp.api.DBAPIEvent;
	import spujol.tfg.sp.preloader.Preloader;
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class AppOriginalBt extends AppButton
	{
		public var author_tf:TextField;
		public var recipe_tf:TextField;
		private var _dbAPI:DBappAPI;
		private var _recipe:String;
		private var _recipeID:String;
		private var _userID:int;
		private var _preloader:Preloader; 

		public function AppOriginalBt(recipe:String, recipeID:String, userID:int) 
		{
			_recipe = recipe;
			_recipeID = recipeID;
			_userID = userID;
			
			super();
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(ev:Event):void {
						
			author_tf.text = "Receta original:";
			recipe_tf.text = _recipe;
			
			this.addEventListener(MouseEvent.CLICK, onClick);
		}
		
		private function onClick(ev:MouseEvent):void{
			
			_dbAPI = new DBappAPI();
			_dbAPI.addEventListener(DBAPIEvent.COMPLETE, viewRecipe);
			_dbAPI.loadFullRecipe("viewRecipe", _recipeID, _userID);
			
			_preloader = new Preloader();
			_preloader.x = stage.stageWidth/2;
			_preloader.y = stage.stageHeight/2;;
			addChild(_preloader);
			
			trace ("O: "+_recipe);
		}
		
		
		/**
		* This method goes to view recipe screen.
		*/
		private function viewRecipe(ev:DBAPIEvent):void {
			var data:Array = ev.data;
			var fullRecipe:Object = new Object();
				fullRecipe.ingredients = data[0];
				fullRecipe.procediments = data[1]; 
				fullRecipe.likeStatus = data[2];
				fullRecipe.loveStatus = data[3];
				fullRecipe.reused = data[4];
				fullRecipe.recipe = data[5];
				
			removeChild(_preloader);
			
			var screenEv:ScreenEvent = new ScreenEvent(ScreenEvent.CHANGE_SCREEN, true, true, ScreenTypes.SCREEN_VIEWRECIPE, fullRecipe);
			dispatchEvent(screenEv);
		}
	}

}