package spujol.tfg.sp.ui.bt
{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class AppPointBt extends Sprite
	{
		
		public var offMode_sp:Sprite;
		public var onMode_sp: Sprite;
		
		private var _state:Boolean;
	
		public function AppPointBt(state:Boolean) 
		{
			_state = state;
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// Change cursor on hover
			this.buttonMode = true;
			// Unable click detection on internal instances
			this.mouseChildren = false;
			
			// Update view
			updateView();
			
			// Eventlisteners
			addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		
		private function clickHandler(ev:MouseEvent):void {
			pointState();
			updateView();
		}
		
		private function pointState():void {
			_state = !_state;
		}
		
		private function updateView():void {
			if(_state == false){
				onMode_sp.visible = false;
				offMode_sp.visible = true;
			} else {
				onMode_sp.visible = true;
				offMode_sp.visible = false;
			}
		}
		
		public function getState():Boolean {
			return _state;
		}
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
			this.removeEventListener(MouseEvent.CLICK,clickHandler);
		}
	}
}