package spujol.tfg.sp.ui.btactive 
{
	import flash.display.Sprite;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	public class AppHelpBt extends Sprite
	{
		public var active_sp:Sprite;
		public var inactive_sp: Sprite;
		protected var _state:Boolean;
	
		public function AppHelpBt(state:Boolean)
		{ 			
			_state = state;
			updateView();
		
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		private function init(ev:Event):void {				
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// Change cursor on hover
			this.buttonMode = true;
			// Unable click detection on internal instances
			this.mouseChildren = false;
			
			// Eventlisteners
			this.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		
		/*
		* This method changes state value and updates view on mouse click
		*/
		protected function clickHandler(ev:MouseEvent):void {
			pointState();
			updateView();
		}
		
		
		/*
		* This method changes state value
		*/		
		private function pointState():void {
			_state = !_state;
		}
		
		
		/*
		* This method updates point view
		*/		
		private function updateView():void {
			if(_state == false){
				active_sp.visible = false;
				inactive_sp.visible = true;
			} else {
				active_sp.visible = true;
				inactive_sp.visible = false;
			}
		}
		
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
			this.removeEventListener(MouseEvent.CLICK,clickHandler);
		}
	}
}