package spujol.tfg.sp.ui.form 
{import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import flash.events.FocusEvent;
	import flash.events.TextEvent;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class InputDropList extends Sprite
	{
		public var onHover_sp:Sprite;
		public var onMode_sp: Sprite;
		public var listBt_sp: Sprite;
		public var inputBoxText_tf:TextField;
		public var container_tf:TextField;
		
		public var textFields:Object = {};

		private var _state:Boolean;
		private var _objects:Object;
		private var _label:String;
		private var _otros:Boolean = false;
		private var _otrosText:String = "";
		
		public function InputDropList(label:String, objects:Object, otros:Boolean = false, otrosText:String = "", state:Boolean = false) 
		{
			_state = state;
			updateView();
			_objects = objects;
		
			_label = label;
			_otros = otros;
			_otrosText = otrosText;
			
			if (_otros == true) {_objects.push("OTROS");}
			
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		

	
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			inputBoxText_tf.text = _label;
			
			container_tf.autoSize = "right";
			container_tf.wordWrap = true;
			container_tf.border = true;
			container_tf.background = true; 
			container_tf.borderColor = 0x999999;
			container_tf.backgroundColor = 0xffffff;
			container_tf.y = onMode_sp.y + onMode_sp.height -4;
			container_tf.x = inputBoxText_tf.x;
			
			removeChild(container_tf);
			
			listBt_sp.buttonMode = true;
			listBt_sp.mouseChildren = false;
			
			this.addEventListener(FocusEvent.FOCUS_IN, focusIN);
			
			listBt_sp.addEventListener(MouseEvent.CLICK, setList);
			updateView();
		}
		
		
		
		
		private function setList(ev:MouseEvent):void {
			
			addChild(container_tf);
			
			container_tf.htmlText = "";

			for (var j:String in _objects){
			
					container_tf.htmlText +=  "<a href=\"event:"+_objects[j]+"\">"+_objects[j]+" </a></br >"; 
					
			}	 
			container_tf.addEventListener(TextEvent.LINK, onClick);
			
			changeListenerF(quitList, setList);
		}	
			
		
		private function onClick (ev:TextEvent):void{
				container_tf.parent.removeChild(container_tf);
				
				if (ev.text == "OTROS"){ 
					inputBoxText_tf.text = _otrosText;
				} else {
					inputBoxText_tf.text = ev.text;
				}
				
				changeListenerF(setList, quitList);
		}
			
		
		private function quitList (ev:MouseEvent):void{
				var text:String = inputBoxText_tf.text
				container_tf.parent.removeChild(container_tf);
				changeListenerF(setList, quitList);
		}
		
		
		private function updateView():void {
			if (_state == false) {	
				onMode_sp.visible = true;
				onHover_sp.visible = false;
					
			} else {
				onMode_sp.visible = false;
				onHover_sp.visible = true;
			}
		}
		
		
		private function changeListenerF(functionOn:Function, functionOff:Function){ 
			listBt_sp.addEventListener(MouseEvent.CLICK, functionOn);
			listBt_sp.removeEventListener(MouseEvent.CLICK, functionOff);
		}
		
		
		private function focusIN(ev:FocusEvent):void{
			inputBoxText_tf.text = "";
			_state = true;
			updateView();
		}

		
		public function clearInput(){
			_state = false;
			
			if(contains(container_tf)){
				changeListenerF(quitList, setList);
			} else {
				changeListenerF(setList, quitList);
			}
			
			updateView();
			inputBoxText_tf.text = _label;
		}
		
		
		public function getText():String{ return inputBoxText_tf.text.toUpperCase();}
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			if (_otros == true) {_objects.pop();}
			
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
			listBt_sp.removeEventListener(MouseEvent.CLICK, setList);
			listBt_sp.removeEventListener(MouseEvent.CLICK, quitList);
		}
		
		public function setState(state:Boolean) {
			_state = state;
		}
	}
}