package spujol.tfg.sp.ui.form 
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import flash.events.FocusEvent;
	import flash.events.TextEvent;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	 
	public class InputTextBox extends Sprite
	{
				
		public var onHover_sp:Sprite;
		public var onMode_sp: Sprite;
		public var inputBoxText_tf:TextField;
		
		public var textFields:Object = {};

		private var _state:Boolean;
		private var _label:String;
		
		public function InputTextBox(label:String) 
		{
						
			_state = false;
			updateView();
		
			_label = label;
			
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}	
	
	
		private function init(ev:Event):void {
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			inputBoxText_tf.text = _label;
			
			this.addEventListener(FocusEvent.FOCUS_IN, focusIN);
			updateView();
		}
		
		
		private function updateView():void {
			if (_state == false) {	
				onMode_sp.visible = true;
				onHover_sp.visible = false;
			} else {
				onMode_sp.visible = false;
				onHover_sp.visible = true;
			}
		}
		
		
		private function focusIN(ev:FocusEvent):void{
			inputBoxText_tf.text = "";
			_state = true;
			updateView();
		}
		
		
		public function clearInput(){
			_state = false;
			updateView();
			inputBoxText_tf.text = _label;
		}
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
		}
	}
}