package spujol.tfg.sp.ui.tab 
{
	import flash.display.Sprite;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import spujol.tfg.sp.screens.basic.ScreenEvent;
	import spujol.tfg.sp.screens.basic.ScreenTypes;
	
	/**
	 * ...
	 * @author sònia pujol
	 * @version 1.0
	 */
	public class AppNewRecipeTab extends Sprite
	{
		public var dataOn:Sprite;
		public var preparationOn: Sprite;
		public var ingredientsOn: Sprite;
		public var tabI_sp: Sprite;
		public var tabP_sp: Sprite;
		public var tabD_sp: Sprite;
		public var tabBar_sp: Sprite;
		
		private var _state:String;
		
		public function AppNewRecipeTab(state:String) 
		{
			_state = state;
			
		
			// To be sure the instance is placed in displayList
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(ev:Event):void {				
			// Remove unused eventlisteners
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			
			
			switch(_state)
			{
				case "ingredients":
					tabP_sp.buttonMode = true;
					tabD_sp.buttonMode = true;
					ingredientsOn.visible = true;
					preparationOn.visible = false;
					dataOn.visible = false;
				break;
				
				case "preparation":
					tabI_sp.buttonMode = true;
					tabD_sp.buttonMode = true;
					ingredientsOn.visible = false;
					preparationOn.visible = true;
					dataOn.visible = false;
				break;
				
				case "recipeData":
					tabI_sp.buttonMode = true;
					tabP_sp.buttonMode = true;
					ingredientsOn.visible = false;
					preparationOn.visible = false;
					dataOn.visible = true;
				break;
			
			}		
		}
		
		/**
		* This method resizes tabs.
		*/
		public function resizeTab(stWidth:int){
				
				tabBar_sp.width = stWidth;
			
				var cenX: int;
				cenX = stWidth/2 - dataOn.width/2;
				ingredientsOn.x = 	cenX;
				preparationOn.x = 	cenX;
				dataOn.x = 	cenX;
				tabI_sp.x = stWidth/2 - tabP_sp.width -tabP_sp.width/2 - 10;
				tabP_sp.x = stWidth/2 - tabP_sp.width/2;
				tabD_sp.x = stWidth/2 + tabP_sp.width/2 +10;
		}
		
		
		/**
		* This method removes listeners.
		*/
		private function dispose(ev:Event):void{
			stage.removeEventListener(Event.REMOVED_FROM_STAGE,dispose);
		}
	}
}